/*	$OpenBSD: wscons_rfont.h,v 1.4 1997/04/08 00:47:21 michaels Exp $ */
/*	$NetBSD: wscons_rfont.h,v 1.1 1996/04/12 02:00:52 cgd Exp $ */

/*
 * Copyright (c) 1992, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * This code is derived from software contributed to the Computer Systems
 * Engineering Group at Lawrence Berkeley Laboratory and to the University
 * of California at Berkeley by Jef Poskanzer.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)gallant19.h	8.1 (Berkeley) 6/11/93
 */

#define null1 {0}
#define	null2 null1, null1
#define	null4 null2, null2
#define	null8 null4, null4
#define	null16 null8, null8
#define	null32 null16, null16
#define	null64 null32, null32
#define	null128 null64, null64


#if 0  /* a font that is to big. */
#define CONSOLE_FONT gallant19

static u_int32_t gallant19_32_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x000018c0, 0x000003c0, 0x000030c0,
    0x000030c0, 0x00001ee0, 0x00000000, 0x00000000, 0x00002000, 0x0000e000,
    0x00006000, 0x00006fc0, 0x00006060, 0x00006060, 0x00007060, 0x00004f80,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_32 = { 12, 22, 1, 1, gallant19_32_pixels, 0 };

static u_int32_t gallant19_33_pixels[] = {
    0x00000000,
    0x06000000, 0x06000000, 0x06000060, 0x06000060, 0x06000060, 0x060031e0,
    0x06006060, 0x06006060, 0x060070e0, 0x06001e70, 0x06000000, 0x00000000,
    0x00000000, 0x06000000, 0x06000000, 0x000030c0, 0x00006060, 0x00006000,
    0x00003000, 0x00000f80, 0x00000000
};
static struct raster gallant19_33 = { 12, 22, 1, 1, gallant19_33_pixels, 0 };

static u_int32_t gallant19_34_pixels[] = {
    0x00000000,
    0x19800c00, 0x19801e00, 0x19800000, 0x19800000, 0x19800000, 0x19800000,
    0x00000000, 0x000031e0, 0x000060c0, 0x00003180, 0x00006000, 0x00003fe0,
    0x00004020, 0x00007fc0, 0x00001000, 0x00007000, 0x00003000, 0x000039c0,
    0x000030c0, 0x000030c0, 0x00000000
};
static struct raster gallant19_34 = { 12, 22, 1, 1, gallant19_34_pixels, 0 };

static u_int32_t gallant19_35_pixels[] = {
    0x00000000,
    0x03300600, 0x03300600, 0x03300600, 0x06601f80, 0x1ff00000, 0x1ff00000,
    0x0cc00000, 0x0cc000c0, 0x19800000, 0x198000c0, 0x7fc000c0, 0x7fc000c0,
    0x330000c0, 0x660000c0, 0x660030c0, 0x00001f00, 0x00006000, 0x00006000,
    0x00006000, 0x00006300, 0x00000000
};
static struct raster gallant19_35 = { 12, 22, 1, 1, gallant19_35_pixels, 0 };

static u_int32_t gallant19_36_pixels[] = {
    0x00000000,
    0x06000600, 0x1f800600, 0x3fc00600, 0x66e00600, 0x66600600, 0x66001f80,
    0x3e000000, 0x1f800000, 0x07c00000, 0x06600000, 0x06600000, 0x66606ee0,
    0x7fc06660, 0x3f806660, 0x06006660, 0x0000ef70, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_36 = { 12, 22, 1, 1, gallant19_36_pixels, 0 };

static u_int32_t gallant19_37_pixels[] = {
    0x00000000,
    0x38600000, 0x44c00000, 0x44c00000, 0x458011c0, 0x39806060, 0x03006060,
    0x03007040, 0x06001f00, 0x0c000000, 0x0c000000, 0x19c00000, 0x1a200000,
    0x32200000, 0x322071c0, 0x61c06060, 0x00006060, 0x00006040, 0x00007f00,
    0x00006000, 0x00006000, 0x00000000
};
static struct raster gallant19_37 = { 12, 22, 1, 1, gallant19_37_pixels, 0 };

static u_int32_t gallant19_38_pixels[] = {
    0x00000000,
    0x07000060, 0x0f800060, 0x18c00000, 0x18c00000, 0x18c00000, 0x0f8034c0,
    0x1e003000, 0x3e003000, 0x77003000, 0x63607800, 0x61e00000, 0x61c00000,
    0x61800000, 0x3fe00000, 0x1e600000, 0x000030c0, 0x00003800, 0x00000780,
    0x000020c0, 0x00003f80, 0x00000000
};
static struct raster gallant19_38 = { 12, 22, 1, 1, gallant19_38_pixels, 0 };

static u_int32_t gallant19_39_pixels[] = {
    0x00000000,
    0x0c000c20, 0x1e000780, 0x1e000000, 0x06000000, 0x06000000, 0x0c000000,
    0x18000000, 0x100030c0, 0x000030c0, 0x000030c0, 0x000030c0, 0x00001e60,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00006020,
    0x00003040, 0x00001880, 0x00000000
};
static struct raster gallant19_39 = { 12, 22, 1, 1, gallant19_39_pixels, 0 };

static u_int32_t gallant19_40_pixels[] = {
    0x00000000,
    0x00c06620, 0x01803b40, 0x03801980, 0x03001980, 0x07000000, 0x06000000,
    0x06000000, 0x06000000, 0x06000000, 0x06007040, 0x07001d00, 0x03000700,
    0x038011c0, 0x0180f1f0, 0x00c00000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00006020, 0x00000000
};
static struct raster gallant19_40 = { 12, 22, 1, 1, gallant19_40_pixels, 0 };

static u_int32_t gallant19_41_pixels[] = {
    0x00000000,
    0x30000000, 0x180060e0, 0x1c000380, 0x0c000e00, 0x0e003820, 0x06007fe0,
    0x06000000, 0x06000000, 0x060001c0, 0x06000300, 0x0e000180, 0x0c000300,
    0x1c000300, 0x18000180, 0x30000300, 0x000001c0, 0x00000000, 0x00000000,
    0x00000600, 0x00000600, 0x00000000
};
static struct raster gallant19_41 = { 12, 22, 1, 1, gallant19_41_pixels, 0 };

static u_int32_t gallant19_42_pixels[] = {
    0x00000000,
    0x00003800, 0x00000c00, 0x00001800, 0x00000c00, 0x0f000c00, 0x06001800,
    0x66600c00, 0x76e03800, 0x19800000, 0x00000000, 0x19800000, 0x76e00000,
    0x66600000, 0x06000000, 0x0f001c20, 0x000036c0, 0x00004380, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_42 = { 12, 22, 1, 1, gallant19_42_pixels, 0 };

static u_int32_t gallant19_43_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x06000000,
    0x06000000, 0x06000000, 0x06000000, 0x7fe00000, 0x7fe00000, 0x06000000,
    0x06000000, 0x06000000, 0x06000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_43 = { 12, 22, 1, 1, gallant19_43_pixels, 0 };

static u_int32_t gallant19_44_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
    0x0c000000, 0x1e000000, 0x1e000000, 0x06000000, 0x06000000, 0x0c000000,
    0x18000000, 0x10000000, 0x00000000
};
static struct raster gallant19_44 = { 12, 22, 1, 1, gallant19_44_pixels, 0 };

static u_int32_t gallant19_45_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x7fe00000, 0x7fe00000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_45 = { 12, 22, 1, 1, gallant19_45_pixels, 0 };

static u_int32_t gallant19_46_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x0c000000,
    0x1e000000, 0x1e000000, 0x0c000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_46 = { 12, 22, 1, 1, gallant19_46_pixels, 0 };

static u_int32_t gallant19_47_pixels[] = {
    0x00000000,
    0x00600000, 0x00c00000, 0x00c00000, 0x01800000, 0x01800000, 0x03000000,
    0x03000000, 0x06000000, 0x0c000000, 0x0c000000, 0x18000000, 0x18000000,
    0x30000000, 0x30000000, 0x60000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_47 = { 12, 22, 1, 1, gallant19_47_pixels, 0 };

static u_int32_t gallant19_48_pixels[] = {
    0x00000000,
    0x07000000, 0x0f800000, 0x11800000, 0x10c00000, 0x30c00000, 0x30c00000,
    0x30c00000, 0x30c00000, 0x30c00000, 0x30c00000, 0x30c00000, 0x30800000,
    0x18800000, 0x1f000000, 0x0e000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_48 = { 12, 22, 1, 1, gallant19_48_pixels, 0 };

static u_int32_t gallant19_49_pixels[] = {
    0x00000000,
    0x02000000, 0x06000000, 0x0e000000, 0x1e000000, 0x36000000, 0x06000000,
    0x06000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000,
    0x06000000, 0x06000000, 0x3fc00000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_49 = { 12, 22, 1, 1, gallant19_49_pixels, 0 };

static u_int32_t gallant19_50_pixels[] = {
    0x00000000,
    0x1f000000, 0x3f800000, 0x61c00000, 0x40c00000, 0x00c00000, 0x00c00000,
    0x00c00000, 0x01800000, 0x03000000, 0x06000000, 0x0c000000, 0x18000000,
    0x30200000, 0x7fe00000, 0x7fe00000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_50 = { 12, 22, 1, 1, gallant19_50_pixels, 0 };

static u_int32_t gallant19_51_pixels[] = {
    0x00000000,
    0x0f800000, 0x1fc00000, 0x20e00000, 0x40600000, 0x00600000, 0x00e00000,
    0x07c00000, 0x0fc00000, 0x00e00000, 0x00600000, 0x00600000, 0x40600000,
    0x60400000, 0x3f800000, 0x1f000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_51 = { 12, 22, 1, 1, gallant19_51_pixels, 0 };

static u_int32_t gallant19_52_pixels[] = {
    0x00000000,
    0x01800000, 0x03800000, 0x03800000, 0x05800000, 0x05800000, 0x09800000,
    0x09800000, 0x11800000, 0x11800000, 0x21800000, 0x3fe00000, 0x7fe00000,
    0x01800000, 0x01800000, 0x01800000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_52 = { 12, 22, 1, 1, gallant19_52_pixels, 0 };

static u_int32_t gallant19_53_pixels[] = {
    0x00000000,
    0x0fc00000, 0x0fc00000, 0x10000000, 0x10000000, 0x20000000, 0x3f800000,
    0x31c00000, 0x00e00000, 0x00600000, 0x00600000, 0x00600000, 0x40600000,
    0x60600000, 0x30c00000, 0x1f800000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_53 = { 12, 22, 1, 1, gallant19_53_pixels, 0 };

static u_int32_t gallant19_54_pixels[] = {
    0x00000000,
    0x07000000, 0x0c000000, 0x18000000, 0x30000000, 0x30000000, 0x60000000,
    0x67800000, 0x6fc00000, 0x70e00000, 0x60600000, 0x60600000, 0x60600000,
    0x70400000, 0x3f800000, 0x1f000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_54 = { 12, 22, 1, 1, gallant19_54_pixels, 0 };

static u_int32_t gallant19_55_pixels[] = {
    0x00000000,
    0x1fe00000, 0x3fe00000, 0x60400000, 0x00400000, 0x00c00000, 0x00800000,
    0x00800000, 0x01800000, 0x01000000, 0x01000000, 0x03000000, 0x02000000,
    0x02000000, 0x06000000, 0x04000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_55 = { 12, 22, 1, 1, gallant19_55_pixels, 0 };

static u_int32_t gallant19_56_pixels[] = {
    0x00000000,
    0x0f000000, 0x11800000, 0x30c00000, 0x30c00000, 0x30c00000, 0x18800000,
    0x0d000000, 0x06000000, 0x0b000000, 0x11800000, 0x30c00000, 0x30c00000,
    0x30c00000, 0x18800000, 0x0f000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_56 = { 12, 22, 1, 1, gallant19_56_pixels, 0 };

static u_int32_t gallant19_57_pixels[] = {
    0x00000000,
    0x0f800000, 0x11c00000, 0x20e00000, 0x60600000, 0x60600000, 0x60600000,
    0x70e00000, 0x3f600000, 0x1e600000, 0x00600000, 0x00c00000, 0x00c00000,
    0x01800000, 0x07000000, 0x3c000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_57 = { 12, 22, 1, 1, gallant19_57_pixels, 0 };

static u_int32_t gallant19_58_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x0c000000,
    0x1e000000, 0x1e000000, 0x0c000000, 0x00000000, 0x00000000, 0x0c000000,
    0x1e000000, 0x1e000000, 0x0c000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_58 = { 12, 22, 1, 1, gallant19_58_pixels, 0 };

static u_int32_t gallant19_59_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
    0x0c000000, 0x1e000000, 0x1e000000, 0x0c000000, 0x00000000, 0x00000000,
    0x0c000000, 0x1e000000, 0x1e000000, 0x06000000, 0x06000000, 0x0c000000,
    0x18000000, 0x10000000, 0x00000000
};
static struct raster gallant19_59 = { 12, 22, 1, 1, gallant19_59_pixels, 0 };

static u_int32_t gallant19_60_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00600000,
    0x01c00000, 0x07000000, 0x1e000000, 0x78000000, 0x78000000, 0x1e000000,
    0x07000000, 0x01c00000, 0x00600000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_60 = { 12, 22, 1, 1, gallant19_60_pixels, 0 };

static u_int32_t gallant19_61_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x7fc00000, 0x7fc00000, 0x00000000, 0x00000000, 0x7fc00000,
    0x7fc00000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_61 = { 12, 22, 1, 1, gallant19_61_pixels, 0 };

static u_int32_t gallant19_62_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x60000000,
    0x38000000, 0x1e000000, 0x07800000, 0x01e00000, 0x01e00000, 0x07800000,
    0x1e000000, 0x38000000, 0x60000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_62 = { 12, 22, 1, 1, gallant19_62_pixels, 0 };

static u_int32_t gallant19_63_pixels[] = {
    0x00000000,
    0x0f000000, 0x1f800000, 0x39c00000, 0x20c00000, 0x00c00000, 0x00c00000,
    0x01800000, 0x03000000, 0x06000000, 0x0c000000, 0x0c000000, 0x00000000,
    0x00000000, 0x0c000000, 0x0c000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_63 = { 12, 22, 1, 1, gallant19_63_pixels, 0 };

static u_int32_t gallant19_64_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x0f800000, 0x3fc00000, 0x30600000,
    0x60600000, 0x67200000, 0x6fa00000, 0x6ca00000, 0x6ca00000, 0x67e00000,
    0x60000000, 0x30000000, 0x3fe00000, 0x0fe00000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_64 = { 12, 22, 1, 1, gallant19_64_pixels, 0 };

static u_int32_t gallant19_65_pixels[] = {
    0x00000000,
    0x00000000, 0x06000000, 0x06000000, 0x0b000000, 0x0b000000, 0x09000000,
    0x11800000, 0x11800000, 0x10800000, 0x3fc00000, 0x20c00000, 0x20400000,
    0x40600000, 0x40600000, 0xe0f00000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_65 = { 12, 22, 1, 1, gallant19_65_pixels, 0 };

static u_int32_t gallant19_66_pixels[] = {
    0x00000000,
    0x00000000, 0xff000000, 0x60800000, 0x60c00000, 0x60c00000, 0x60c00000,
    0x61800000, 0x7f800000, 0x60c00000, 0x60600000, 0x60600000, 0x60600000,
    0x60600000, 0x60c00000, 0xff800000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_66 = { 12, 22, 1, 1, gallant19_66_pixels, 0 };

static u_int32_t gallant19_67_pixels[] = {
    0x00000000,
    0x00000000, 0x0fc00000, 0x10600000, 0x20200000, 0x20000000, 0x60000000,
    0x60000000, 0x60000000, 0x60000000, 0x60000000, 0x60000000, 0x20000000,
    0x30200000, 0x18400000, 0x0f800000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_67 = { 12, 22, 1, 1, gallant19_67_pixels, 0 };

static u_int32_t gallant19_68_pixels[] = {
    0x00000000,
    0x00000000, 0xff000000, 0x61c00000, 0x60c00000, 0x60600000, 0x60600000,
    0x60600000, 0x60600000, 0x60600000, 0x60600000, 0x60600000, 0x60600000,
    0x60400000, 0x61800000, 0xfe000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_68 = { 12, 22, 1, 1, gallant19_68_pixels, 0 };

static u_int32_t gallant19_69_pixels[] = {
    0x00000000,
    0x00000000, 0x7fc00000, 0x30400000, 0x30400000, 0x30000000, 0x30000000,
    0x30800000, 0x3f800000, 0x30800000, 0x30000000, 0x30000000, 0x30000000,
    0x30200000, 0x30200000, 0x7fe00000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_69 = { 12, 22, 1, 1, gallant19_69_pixels, 0 };

static u_int32_t gallant19_70_pixels[] = {
    0x00000000,
    0x00000000, 0x7fc00000, 0x30400000, 0x30400000, 0x30000000, 0x30000000,
    0x30800000, 0x3f800000, 0x30800000, 0x30000000, 0x30000000, 0x30000000,
    0x30000000, 0x30000000, 0x78000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_70 = { 12, 22, 1, 1, gallant19_70_pixels, 0 };

static u_int32_t gallant19_71_pixels[] = {
    0x00000000,
    0x00000000, 0x0fc00000, 0x10600000, 0x20200000, 0x20000000, 0x60000000,
    0x60000000, 0x60000000, 0x60000000, 0x61f00000, 0x60600000, 0x20600000,
    0x30600000, 0x18600000, 0x0f800000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_71 = { 12, 22, 1, 1, gallant19_71_pixels, 0 };

static u_int32_t gallant19_72_pixels[] = {
    0x00000000,
    0x00000000, 0xf0f00000, 0x60600000, 0x60600000, 0x60600000, 0x60600000,
    0x60600000, 0x7fe00000, 0x60600000, 0x60600000, 0x60600000, 0x60600000,
    0x60600000, 0x60600000, 0xf0f00000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_72 = { 12, 22, 1, 1, gallant19_72_pixels, 0 };

static u_int32_t gallant19_73_pixels[] = {
    0x00000000,
    0x00000000, 0x1f800000, 0x06000000, 0x06000000, 0x06000000, 0x06000000,
    0x06000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000,
    0x06000000, 0x06000000, 0x1f800000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_73 = { 12, 22, 1, 1, gallant19_73_pixels, 0 };

static u_int32_t gallant19_74_pixels[] = {
    0x00000000,
    0x00000000, 0x1f800000, 0x06000000, 0x06000000, 0x06000000, 0x06000000,
    0x06000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000,
    0x06000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000, 0x04000000,
    0x38000000, 0x30000000, 0x00000000
};
static struct raster gallant19_74 = { 12, 22, 1, 1, gallant19_74_pixels, 0 };

static u_int32_t gallant19_75_pixels[] = {
    0x00000000,
    0x00000000, 0xf0e00000, 0x61800000, 0x63000000, 0x66000000, 0x6c000000,
    0x78000000, 0x78000000, 0x7c000000, 0x6e000000, 0x67000000, 0x63800000,
    0x61c00000, 0x60e00000, 0xf0700000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_75 = { 12, 22, 1, 1, gallant19_75_pixels, 0 };

static u_int32_t gallant19_76_pixels[] = {
    0x00000000,
    0x00000000, 0x78000000, 0x30000000, 0x30000000, 0x30000000, 0x30000000,
    0x30000000, 0x30000000, 0x30000000, 0x30000000, 0x30000000, 0x30000000,
    0x30200000, 0x30200000, 0x7fe00000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_76 = { 12, 22, 1, 1, gallant19_76_pixels, 0 };

static u_int32_t gallant19_77_pixels[] = {
    0x00000000,
    0x00000000, 0xe0700000, 0x60e00000, 0x70e00000, 0x70e00000, 0x70e00000,
    0x59600000, 0x59600000, 0x59600000, 0x4d600000, 0x4e600000, 0x4e600000,
    0x44600000, 0x44600000, 0xe4f00000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_77 = { 12, 22, 1, 1, gallant19_77_pixels, 0 };

static u_int32_t gallant19_78_pixels[] = {
    0x00000000,
    0x00000000, 0xc0700000, 0x60200000, 0x70200000, 0x78200000, 0x58200000,
    0x4c200000, 0x46200000, 0x47200000, 0x43200000, 0x41a00000, 0x40e00000,
    0x40e00000, 0x40600000, 0xe0300000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_78 = { 12, 22, 1, 1, gallant19_78_pixels, 0 };

static u_int32_t gallant19_79_pixels[] = {
    0x00000000,
    0x00000000, 0x0f000000, 0x11c00000, 0x20c00000, 0x20600000, 0x60600000,
    0x60600000, 0x60600000, 0x60600000, 0x60600000, 0x60600000, 0x20400000,
    0x30400000, 0x18800000, 0x0f000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_79 = { 12, 22, 1, 1, gallant19_79_pixels, 0 };

static u_int32_t gallant19_80_pixels[] = {
    0x00000000,
    0x00000000, 0x7f800000, 0x30c00000, 0x30600000, 0x30600000, 0x30600000,
    0x30c00000, 0x37800000, 0x30000000, 0x30000000, 0x30000000, 0x30000000,
    0x30000000, 0x30000000, 0x78000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_80 = { 12, 22, 1, 1, gallant19_80_pixels, 0 };

static u_int32_t gallant19_81_pixels[] = {
    0x00000000,
    0x00000000, 0x0f000000, 0x11c00000, 0x20c00000, 0x20600000, 0x60600000,
    0x60600000, 0x60600000, 0x60600000, 0x60600000, 0x60600000, 0x30400000,
    0x38400000, 0x1f800000, 0x0e000000, 0x1f000000, 0x23900000, 0x01e00000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_81 = { 12, 22, 1, 1, gallant19_81_pixels, 0 };

static u_int32_t gallant19_82_pixels[] = {
    0x00000000,
    0x00000000, 0xff000000, 0x61800000, 0x60c00000, 0x60c00000, 0x60c00000,
    0x60800000, 0x7f000000, 0x7c000000, 0x6e000000, 0x67000000, 0x63800000,
    0x61c00000, 0x60e00000, 0xf0700000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_82 = { 12, 22, 1, 1, gallant19_82_pixels, 0 };

static u_int32_t gallant19_83_pixels[] = {
    0x00000000,
    0x00000000, 0x1fe00000, 0x30600000, 0x60200000, 0x60200000, 0x70000000,
    0x3c000000, 0x1e000000, 0x07800000, 0x01c00000, 0x00e00000, 0x40600000,
    0x40600000, 0x60c00000, 0x7f800000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_83 = { 12, 22, 1, 1, gallant19_83_pixels, 0 };

static u_int32_t gallant19_84_pixels[] = {
    0x00000000,
    0x00000000, 0x7fe00000, 0x46200000, 0x06000000, 0x06000000, 0x06000000,
    0x06000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000,
    0x06000000, 0x06000000, 0x1f800000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_84 = { 12, 22, 1, 1, gallant19_84_pixels, 0 };

static u_int32_t gallant19_85_pixels[] = {
    0x00000000,
    0x00000000, 0xf0700000, 0x60200000, 0x60200000, 0x60200000, 0x60200000,
    0x60200000, 0x60200000, 0x60200000, 0x60200000, 0x60200000, 0x60200000,
    0x70400000, 0x3fc00000, 0x1f800000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_85 = { 12, 22, 1, 1, gallant19_85_pixels, 0 };

static u_int32_t gallant19_86_pixels[] = {
    0x00000000,
    0x00000000, 0xe0e00000, 0x60400000, 0x30800000, 0x30800000, 0x30800000,
    0x19000000, 0x19000000, 0x19000000, 0x0c000000, 0x0e000000, 0x0e000000,
    0x04000000, 0x04000000, 0x04000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_86 = { 12, 22, 1, 1, gallant19_86_pixels, 0 };

static u_int32_t gallant19_87_pixels[] = {
    0x00000000,
    0x00000000, 0xfef00000, 0x66200000, 0x66200000, 0x66200000, 0x76200000,
    0x77400000, 0x33400000, 0x37400000, 0x3bc00000, 0x3b800000, 0x19800000,
    0x19800000, 0x19800000, 0x19800000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_87 = { 12, 22, 1, 1, gallant19_87_pixels, 0 };

static u_int32_t gallant19_88_pixels[] = {
    0x00000000,
    0x00000000, 0xf0700000, 0x60200000, 0x30400000, 0x38800000, 0x18800000,
    0x0d000000, 0x06000000, 0x06000000, 0x0b000000, 0x11800000, 0x11c00000,
    0x20c00000, 0x40600000, 0xe0f00000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_88 = { 12, 22, 1, 1, gallant19_88_pixels, 0 };

static u_int32_t gallant19_89_pixels[] = {
    0x00000000,
    0x00000000, 0xf0700000, 0x60200000, 0x30400000, 0x18800000, 0x18800000,
    0x0d000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000,
    0x06000000, 0x06000000, 0x0f000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_89 = { 12, 22, 1, 1, gallant19_89_pixels, 0 };

static u_int32_t gallant19_90_pixels[] = {
    0x00000000,
    0x00000000, 0x3fe00000, 0x20c00000, 0x00c00000, 0x01800000, 0x01800000,
    0x03000000, 0x03000000, 0x06000000, 0x06000000, 0x0c000000, 0x0c000000,
    0x18000000, 0x18200000, 0x3fe00000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_90 = { 12, 22, 1, 1, gallant19_90_pixels, 0 };

static u_int32_t gallant19_91_pixels[] = {
    0x00000000,
    0x07c00000, 0x07c00000, 0x06000000, 0x06000000, 0x06000000, 0x06000000,
    0x06000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000,
    0x06000000, 0x07c00000, 0x07c00000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_91 = { 12, 22, 1, 1, gallant19_91_pixels, 0 };

static u_int32_t gallant19_92_pixels[] = {
    0x00000000,
    0x60000000, 0x60000000, 0x30000000, 0x30000000, 0x18000000, 0x18000000,
    0x0c000000, 0x0c000000, 0x06000000, 0x03000000, 0x03000000, 0x01800000,
    0x01800000, 0x00c00000, 0x00c00000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_92 = { 12, 22, 1, 1, gallant19_92_pixels, 0 };

static u_int32_t gallant19_93_pixels[] = {
    0x00000000,
    0x7c000000, 0x7c000000, 0x0c000000, 0x0c000000, 0x0c000000, 0x0c000000,
    0x0c000000, 0x0c000000, 0x0c000000, 0x0c000000, 0x0c000000, 0x0c000000,
    0x0c000000, 0x7c000000, 0x7c000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_93 = { 12, 22, 1, 1, gallant19_93_pixels, 0 };

static u_int32_t gallant19_94_pixels[] = {
    0x00000000,
    0x04000000, 0x0e000000, 0x1b000000, 0x31800000, 0x60c00000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_94 = { 12, 22, 1, 1, gallant19_94_pixels, 0 };

static u_int32_t gallant19_95_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0xfff00000, 0xfff00000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_95 = { 12, 22, 1, 1, gallant19_95_pixels, 0 };

static u_int32_t gallant19_96_pixels[] = {
    0x00000000,
    0x01000000, 0x03000000, 0x06000000, 0x06000000, 0x07800000, 0x07800000,
    0x03000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_96 = { 12, 22, 1, 1, gallant19_96_pixels, 0 };

static u_int32_t gallant19_97_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x0f800000,
    0x18c00000, 0x10c00000, 0x03c00000, 0x1cc00000, 0x30c00000, 0x30c00000,
    0x30c00000, 0x39c00000, 0x1ee00000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_97 = { 12, 22, 1, 1, gallant19_97_pixels, 0 };

static u_int32_t gallant19_98_pixels[] = {
    0x00000000,
    0x20000000, 0x60000000, 0xe0000000, 0x60000000, 0x60000000, 0x67800000,
    0x6fc00000, 0x70e00000, 0x60600000, 0x60600000, 0x60600000, 0x60600000,
    0x70600000, 0x78c00000, 0x4f800000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_98 = { 12, 22, 1, 1, gallant19_98_pixels, 0 };

static u_int32_t gallant19_99_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x1f800000,
    0x31c00000, 0x20c00000, 0x60000000, 0x60000000, 0x60000000, 0x60000000,
    0x70400000, 0x30c00000, 0x1f800000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_99 = { 12, 22, 1, 1, gallant19_99_pixels, 0 };

static u_int32_t gallant19_100_pixels[] = {
    0x00000000,
    0x00600000, 0x00e00000, 0x00600000, 0x00600000, 0x00600000, 0x0f600000,
    0x31e00000, 0x20e00000, 0x60600000, 0x60600000, 0x60600000, 0x60600000,
    0x70e00000, 0x39600000, 0x1e700000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_100 = { 12, 22, 1, 1, gallant19_100_pixels, 0 };

static u_int32_t gallant19_101_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x0f000000,
    0x30c00000, 0x60600000, 0x60600000, 0x7fe00000, 0x60000000, 0x60000000,
    0x30000000, 0x18600000, 0x0f800000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_101 = { 12, 22, 1, 1, gallant19_101_pixels, 0 };

static u_int32_t gallant19_102_pixels[] = {
    0x00000000,
    0x03800000, 0x04c00000, 0x04c00000, 0x0c000000, 0x0c000000, 0x0c000000,
    0x0c000000, 0x1f800000, 0x0c000000, 0x0c000000, 0x0c000000, 0x0c000000,
    0x0c000000, 0x0c000000, 0x1e000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_102 = { 12, 22, 1, 1, gallant19_102_pixels, 0 };

static u_int32_t gallant19_103_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x1f200000,
    0x31e00000, 0x60c00000, 0x60c00000, 0x60c00000, 0x31800000, 0x3f000000,
    0x60000000, 0x7fc00000, 0x3fe00000, 0x20600000, 0x40200000, 0x40200000,
    0x7fc00000, 0x3f800000, 0x00000000
};
static struct raster gallant19_103 = { 12, 22, 1, 1, gallant19_103_pixels, 0 };

static u_int32_t gallant19_104_pixels[] = {
    0x00000000,
    0x10000000, 0x30000000, 0x70000000, 0x30000000, 0x30000000, 0x37800000,
    0x39c00000, 0x30c00000, 0x30c00000, 0x30c00000, 0x30c00000, 0x30c00000,
    0x30c00000, 0x30c00000, 0x79e00000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_104 = { 12, 22, 1, 1, gallant19_104_pixels, 0 };

static u_int32_t gallant19_105_pixels[] = {
    0x00000000,
    0x00000000, 0x06000000, 0x06000000, 0x00000000, 0x00000000, 0x1e000000,
    0x06000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000,
    0x06000000, 0x06000000, 0x1f800000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_105 = { 12, 22, 1, 1, gallant19_105_pixels, 0 };

static u_int32_t gallant19_106_pixels[] = {
    0x00000000,
    0x00000000, 0x00c00000, 0x00c00000, 0x00000000, 0x00000000, 0x03c00000,
    0x00c00000, 0x00c00000, 0x00c00000, 0x00c00000, 0x00c00000, 0x00c00000,
    0x00c00000, 0x00c00000, 0x00c00000, 0x20c00000, 0x30c00000, 0x38800000,
    0x1f000000, 0x0e000000, 0x00000000
};
static struct raster gallant19_106 = { 12, 22, 1, 1, gallant19_106_pixels, 0 };

static u_int32_t gallant19_107_pixels[] = {
    0x00000000,
    0x60000000, 0xe0000000, 0x60000000, 0x60000000, 0x60000000, 0x61c00000,
    0x63000000, 0x66000000, 0x7c000000, 0x78000000, 0x7c000000, 0x6e000000,
    0x67000000, 0x63800000, 0xf1e00000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_107 = { 12, 22, 1, 1, gallant19_107_pixels, 0 };

static u_int32_t gallant19_108_pixels[] = {
    0x00000000,
    0x1e000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000,
    0x06000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000,
    0x06000000, 0x06000000, 0x1f800000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_108 = { 12, 22, 1, 1, gallant19_108_pixels, 0 };

static u_int32_t gallant19_109_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0xddc00000,
    0x6ee00000, 0x66600000, 0x66600000, 0x66600000, 0x66600000, 0x66600000,
    0x66600000, 0x66600000, 0xef700000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_109 = { 12, 22, 1, 1, gallant19_109_pixels, 0 };

static u_int32_t gallant19_110_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x27800000,
    0x79c00000, 0x30c00000, 0x30c00000, 0x30c00000, 0x30c00000, 0x30c00000,
    0x30c00000, 0x30c00000, 0x79e00000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_110 = { 12, 22, 1, 1, gallant19_110_pixels, 0 };

static u_int32_t gallant19_111_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x0f800000,
    0x11c00000, 0x20e00000, 0x60600000, 0x60600000, 0x60600000, 0x60600000,
    0x70400000, 0x38800000, 0x1f000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_111 = { 12, 22, 1, 1, gallant19_111_pixels, 0 };

static u_int32_t gallant19_112_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0xef800000,
    0x71c00000, 0x60e00000, 0x60600000, 0x60600000, 0x60600000, 0x60600000,
    0x60400000, 0x70800000, 0x7f000000, 0x60000000, 0x60000000, 0x60000000,
    0x60000000, 0xf0000000, 0x00000000
};
static struct raster gallant19_112 = { 12, 22, 1, 1, gallant19_112_pixels, 0 };

static u_int32_t gallant19_113_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x0f200000,
    0x11e00000, 0x20e00000, 0x60600000, 0x60600000, 0x60600000, 0x60600000,
    0x70600000, 0x38e00000, 0x1fe00000, 0x00600000, 0x00600000, 0x00600000,
    0x00600000, 0x00f00000, 0x00000000
};
static struct raster gallant19_113 = { 12, 22, 1, 1, gallant19_113_pixels, 0 };

static u_int32_t gallant19_114_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x73800000,
    0x34c00000, 0x38c00000, 0x30000000, 0x30000000, 0x30000000, 0x30000000,
    0x30000000, 0x30000000, 0x78000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_114 = { 12, 22, 1, 1, gallant19_114_pixels, 0 };

static u_int32_t gallant19_115_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x1fc00000,
    0x30c00000, 0x30400000, 0x38000000, 0x1e000000, 0x07800000, 0x01c00000,
    0x20c00000, 0x30c00000, 0x3f800000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_115 = { 12, 22, 1, 1, gallant19_115_pixels, 0 };

static u_int32_t gallant19_116_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x04000000, 0x04000000, 0x0c000000, 0x7fc00000,
    0x0c000000, 0x0c000000, 0x0c000000, 0x0c000000, 0x0c000000, 0x0c000000,
    0x0c200000, 0x0e400000, 0x07800000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_116 = { 12, 22, 1, 1, gallant19_116_pixels, 0 };

static u_int32_t gallant19_117_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x79e00000,
    0x30c00000, 0x30c00000, 0x30c00000, 0x30c00000, 0x30c00000, 0x30c00000,
    0x30c00000, 0x39c00000, 0x1e600000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_117 = { 12, 22, 1, 1, gallant19_117_pixels, 0 };

static u_int32_t gallant19_118_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0xf0700000,
    0x60200000, 0x30400000, 0x30400000, 0x18800000, 0x18800000, 0x0d000000,
    0x0d000000, 0x06000000, 0x06000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_118 = { 12, 22, 1, 1, gallant19_118_pixels, 0 };

static u_int32_t gallant19_119_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0xff700000,
    0x66200000, 0x66200000, 0x66200000, 0x37400000, 0x3b400000, 0x3b400000,
    0x19800000, 0x19800000, 0x19800000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_119 = { 12, 22, 1, 1, gallant19_119_pixels, 0 };

static u_int32_t gallant19_120_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0xf8f00000,
    0x70400000, 0x38800000, 0x1d000000, 0x0e000000, 0x07000000, 0x0b800000,
    0x11c00000, 0x20e00000, 0xf1f00000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_120 = { 12, 22, 1, 1, gallant19_120_pixels, 0 };

static u_int32_t gallant19_121_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0xf0f00000,
    0x60200000, 0x30400000, 0x30400000, 0x18800000, 0x18800000, 0x0d000000,
    0x0d000000, 0x06000000, 0x06000000, 0x04000000, 0x0c000000, 0x08000000,
    0x78000000, 0x70000000, 0x00000000
};
static struct raster gallant19_121 = { 12, 22, 1, 1, gallant19_121_pixels, 0 };

static u_int32_t gallant19_122_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x7fe00000,
    0x60e00000, 0x41c00000, 0x03800000, 0x07000000, 0x0e000000, 0x1c000000,
    0x38200000, 0x70600000, 0x7fe00000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_122 = { 12, 22, 1, 1, gallant19_122_pixels, 0 };

static u_int32_t gallant19_123_pixels[] = {
    0x00000000,
    0x01c00000, 0x03000000, 0x03000000, 0x01800000, 0x01800000, 0x01800000,
    0x03000000, 0x07000000, 0x03000000, 0x01800000, 0x01800000, 0x01800000,
    0x03000000, 0x03000000, 0x01c00000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_123 = { 12, 22, 1, 1, gallant19_123_pixels, 0 };

static u_int32_t gallant19_124_pixels[] = {
    0x00000000,
    0x06000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000,
    0x06000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000,
    0x06000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000, 0x06000000,
    0x06000000, 0x06000000, 0x00000000
};
static struct raster gallant19_124 = { 12, 22, 1, 1, gallant19_124_pixels, 0 };

static u_int32_t gallant19_125_pixels[] = {
    0x00000000,
    0x38000000, 0x0c000000, 0x0c000000, 0x18000000, 0x18000000, 0x18000000,
    0x0c000000, 0x0e000000, 0x0c000000, 0x18000000, 0x18000000, 0x18000000,
    0x0c000000, 0x0c000000, 0x38000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_125 = { 12, 22, 1, 1, gallant19_125_pixels, 0 };

static u_int32_t gallant19_126_pixels[] = {
    0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x1c200000, 0x3e600000, 0x36c00000, 0x67c00000,
    0x43800000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000
};
static struct raster gallant19_126 = { 12, 22, 1, 1, gallant19_126_pixels, 0 };

struct raster_font gallant19 = {
    12, 22, 15, RASFONT_FIXEDWIDTH|RASFONT_NOVERTICALMOVEMENT, 
    {
	null32,
	{ &gallant19_32, 0, -15, 12, 0 },
	{ &gallant19_33, 0, -15, 12, 0 },
	{ &gallant19_34, 0, -15, 12, 0 },
	{ &gallant19_35, 0, -15, 12, 0 },
	{ &gallant19_36, 0, -15, 12, 0 },
	{ &gallant19_37, 0, -15, 12, 0 },
	{ &gallant19_38, 0, -15, 12, 0 },
	{ &gallant19_39, 0, -15, 12, 0 },
	{ &gallant19_40, 0, -15, 12, 0 },
	{ &gallant19_41, 0, -15, 12, 0 },
	{ &gallant19_42, 0, -15, 12, 0 },
	{ &gallant19_43, 0, -15, 12, 0 },
	{ &gallant19_44, 0, -15, 12, 0 },
	{ &gallant19_45, 0, -15, 12, 0 },
	{ &gallant19_46, 0, -15, 12, 0 },
	{ &gallant19_47, 0, -15, 12, 0 },
	{ &gallant19_48, 0, -15, 12, 0 },
	{ &gallant19_49, 0, -15, 12, 0 },
	{ &gallant19_50, 0, -15, 12, 0 },
	{ &gallant19_51, 0, -15, 12, 0 },
	{ &gallant19_52, 0, -15, 12, 0 },
	{ &gallant19_53, 0, -15, 12, 0 },
	{ &gallant19_54, 0, -15, 12, 0 },
	{ &gallant19_55, 0, -15, 12, 0 },
	{ &gallant19_56, 0, -15, 12, 0 },
	{ &gallant19_57, 0, -15, 12, 0 },
	{ &gallant19_58, 0, -15, 12, 0 },
	{ &gallant19_59, 0, -15, 12, 0 },
	{ &gallant19_60, 0, -15, 12, 0 },
	{ &gallant19_61, 0, -15, 12, 0 },
	{ &gallant19_62, 0, -15, 12, 0 },
	{ &gallant19_63, 0, -15, 12, 0 },
	{ &gallant19_64, 0, -15, 12, 0 },
	{ &gallant19_65, 0, -15, 12, 0 },
	{ &gallant19_66, 0, -15, 12, 0 },
	{ &gallant19_67, 0, -15, 12, 0 },
	{ &gallant19_68, 0, -15, 12, 0 },
	{ &gallant19_69, 0, -15, 12, 0 },
	{ &gallant19_70, 0, -15, 12, 0 },
	{ &gallant19_71, 0, -15, 12, 0 },
	{ &gallant19_72, 0, -15, 12, 0 },
	{ &gallant19_73, 0, -15, 12, 0 },
	{ &gallant19_74, 0, -15, 12, 0 },
	{ &gallant19_75, 0, -15, 12, 0 },
	{ &gallant19_76, 0, -15, 12, 0 },
	{ &gallant19_77, 0, -15, 12, 0 },
	{ &gallant19_78, 0, -15, 12, 0 },
	{ &gallant19_79, 0, -15, 12, 0 },
	{ &gallant19_80, 0, -15, 12, 0 },
	{ &gallant19_81, 0, -15, 12, 0 },
	{ &gallant19_82, 0, -15, 12, 0 },
	{ &gallant19_83, 0, -15, 12, 0 },
	{ &gallant19_84, 0, -15, 12, 0 },
	{ &gallant19_85, 0, -15, 12, 0 },
	{ &gallant19_86, 0, -15, 12, 0 },
	{ &gallant19_87, 0, -15, 12, 0 },
	{ &gallant19_88, 0, -15, 12, 0 },
	{ &gallant19_89, 0, -15, 12, 0 },
	{ &gallant19_90, 0, -15, 12, 0 },
	{ &gallant19_91, 0, -15, 12, 0 },
	{ &gallant19_92, 0, -15, 12, 0 },
	{ &gallant19_93, 0, -15, 12, 0 },
	{ &gallant19_94, 0, -15, 12, 0 },
	{ &gallant19_95, 0, -15, 12, 0 },
	{ &gallant19_96, 0, -15, 12, 0 },
	{ &gallant19_97, 0, -15, 12, 0 },
	{ &gallant19_98, 0, -15, 12, 0 },
	{ &gallant19_99, 0, -15, 12, 0 },
	{ &gallant19_100, 0, -15, 12, 0 },
	{ &gallant19_101, 0, -15, 12, 0 },
	{ &gallant19_102, 0, -15, 12, 0 },
	{ &gallant19_103, 0, -15, 12, 0 },
	{ &gallant19_104, 0, -15, 12, 0 },
	{ &gallant19_105, 0, -15, 12, 0 },
	{ &gallant19_106, 0, -15, 12, 0 },
	{ &gallant19_107, 0, -15, 12, 0 },
	{ &gallant19_108, 0, -15, 12, 0 },
	{ &gallant19_109, 0, -15, 12, 0 },
	{ &gallant19_110, 0, -15, 12, 0 },
	{ &gallant19_111, 0, -15, 12, 0 },
	{ &gallant19_112, 0, -15, 12, 0 },
	{ &gallant19_113, 0, -15, 12, 0 },
	{ &gallant19_114, 0, -15, 12, 0 },
	{ &gallant19_115, 0, -15, 12, 0 },
	{ &gallant19_116, 0, -15, 12, 0 },
	{ &gallant19_117, 0, -15, 12, 0 },
	{ &gallant19_118, 0, -15, 12, 0 },
	{ &gallant19_119, 0, -15, 12, 0 },
	{ &gallant19_120, 0, -15, 12, 0 },
	{ &gallant19_121, 0, -15, 12, 0 },
	{ &gallant19_122, 0, -15, 12, 0 },
	{ &gallant19_123, 0, -15, 12, 0 },
	{ &gallant19_124, 0, -15, 12, 0 },
	{ &gallant19_125, 0, -15, 12, 0 },
	{ &gallant19_126, 0, -15, 12, 0 },
	{ 0 },
	null128
    },
#ifdef COLORFONT_CACHE
    (struct raster_fontcache*) -1
#endif /*COLORFONT_CACHE*/
};

#else /* a font that is not to big.  This is from arch/sparc/dev/rcons_font.h */
#define CONSOLE_FONT font_fixed

static u_int32_t font_fixed_0_pixels[] = {
	0,0xf0000000,0xf0000000,0xf0000000,0xf0000000,0xf0000000,0xf0000000,0xf0000000,0xf0000000,0xf0000000,0,0,0
};
static struct raster font_fixed_0 = { 6, 13, 1, 1, font_fixed_0_pixels, 0 };

static u_int32_t font_fixed_1_pixels[] = {
	0,0,0,0,0,0x20000000,0x70000000,0xf8000000,0x70000000,0x20000000,0,0,0
};
static struct raster font_fixed_1 = { 6, 13, 1, 1, font_fixed_1_pixels, 0 };

static u_int32_t font_fixed_2_pixels[] = {
	0,0,0,0,0xa8000000,0x50000000,0xa8000000,0x50000000,0xa8000000,0x50000000,0xa8000000,0,0
};
static struct raster font_fixed_2 = { 6, 13, 1, 1, font_fixed_2_pixels, 0 };

static u_int32_t font_fixed_3_pixels[] = {
	0,0,0,0,0xa0000000,0xa0000000,0xe0000000,0xa0000000,0xa0000000,0x70000000,0x20000000,0x20000000,0x20000000
};
static struct raster font_fixed_3 = { 6, 13, 1, 1, font_fixed_3_pixels, 0 };

static u_int32_t font_fixed_4_pixels[] = {
	0,0,0,0,0xe0000000,0x80000000,0xc0000000,0x80000000,0xf0000000,0x40000000,0x60000000,0x40000000,0x40000000
};
static struct raster font_fixed_4 = { 6, 13, 1, 1, font_fixed_4_pixels, 0 };

static u_int32_t font_fixed_5_pixels[] = {
	0,0,0,0,0x70000000,0x80000000,0x80000000,0x70000000,0x70000000,0x48000000,0x70000000,0x50000000,0x48000000
};
static struct raster font_fixed_5 = { 6, 13, 1, 1, font_fixed_5_pixels, 0 };

static u_int32_t font_fixed_6_pixels[] = {
	0,0,0,0,0x80000000,0x80000000,0x80000000,0xe0000000,0x70000000,0x40000000,0x60000000,0x40000000,0x40000000
};
static struct raster font_fixed_6 = { 6, 13, 1, 1, font_fixed_6_pixels, 0 };

static u_int32_t font_fixed_7_pixels[] = {
	0,0,0,0,0x60000000,0x90000000,0x90000000,0x60000000,0,0,0,0,0
};
static struct raster font_fixed_7 = { 6, 13, 1, 1, font_fixed_7_pixels, 0 };

static u_int32_t font_fixed_8_pixels[] = {
	0,0,0,0,0x20000000,0x20000000,0xf8000000,0x20000000,0x20000000,0,0xf8000000,0,0
};
static struct raster font_fixed_8 = { 6, 13, 1, 1, font_fixed_8_pixels, 0 };

static u_int32_t font_fixed_9_pixels[] = {
	0,0,0,0,0x88000000,0xc8000000,0xa8000000,0x98000000,0x88000000,0x40000000,0x40000000,0x40000000,0x78000000
};
static struct raster font_fixed_9 = { 6, 13, 1, 1, font_fixed_9_pixels, 0 };

static u_int32_t font_fixed_10_pixels[] = {
	0,0,0,0,0x88000000,0x88000000,0x50000000,0x20000000,0,0xf8000000,0x20000000,0x20000000,0x20000000
};
static struct raster font_fixed_10 = { 6, 13, 1, 1, font_fixed_10_pixels, 0 };

static u_int32_t font_fixed_11_pixels[] = {
	0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0xe0000000,0,0,0,0,0
};
static struct raster font_fixed_11 = { 6, 13, 1, 1, font_fixed_11_pixels, 0 };

static u_int32_t font_fixed_12_pixels[] = {
	0,0,0,0,0,0,0,0xe0000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000
};
static struct raster font_fixed_12 = { 6, 13, 1, 1, font_fixed_12_pixels, 0 };

static u_int32_t font_fixed_13_pixels[] = {
	0,0,0,0,0,0,0,0x3c000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000
};
static struct raster font_fixed_13 = { 6, 13, 1, 1, font_fixed_13_pixels, 0 };

static u_int32_t font_fixed_14_pixels[] = {
	0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x3c000000,0,0,0,0,0
};
static struct raster font_fixed_14 = { 6, 13, 1, 1, font_fixed_14_pixels, 0 };

static u_int32_t font_fixed_15_pixels[] = {
	0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0xfc000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000
};
static struct raster font_fixed_15 = { 6, 13, 1, 1, font_fixed_15_pixels, 0 };

static u_int32_t font_fixed_16_pixels[] = {
	0,0,0,0xfc000000,0,0,0,0,0,0,0,0,0
};
static struct raster font_fixed_16 = { 6, 13, 1, 1, font_fixed_16_pixels, 0 };

static u_int32_t font_fixed_17_pixels[] = {
	0,0,0,0,0,0xfc000000,0,0,0,0,0,0,0
};
static struct raster font_fixed_17 = { 6, 13, 1, 1, font_fixed_17_pixels, 0 };

static u_int32_t font_fixed_18_pixels[] = {
	0,0,0,0,0,0,0,0xfc000000,0,0,0,0,0
};
static struct raster font_fixed_18 = { 6, 13, 1, 1, font_fixed_18_pixels, 0 };

static u_int32_t font_fixed_19_pixels[] = {
	0,0,0,0,0,0,0,0,0,0xfc000000,0,0,0
};
static struct raster font_fixed_19 = { 6, 13, 1, 1, font_fixed_19_pixels, 0 };

static u_int32_t font_fixed_20_pixels[] = {
	0,0,0,0,0,0,0,0,0,0,0,0xfc000000,0
};
static struct raster font_fixed_20 = { 6, 13, 1, 1, font_fixed_20_pixels, 0 };

static u_int32_t font_fixed_21_pixels[] = {
	0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x3c000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000
};
static struct raster font_fixed_21 = { 6, 13, 1, 1, font_fixed_21_pixels, 0 };

static u_int32_t font_fixed_22_pixels[] = {
	0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0xe0000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000
};
static struct raster font_fixed_22 = { 6, 13, 1, 1, font_fixed_22_pixels, 0 };

static u_int32_t font_fixed_23_pixels[] = {
	0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0xfc000000,0,0,0,0,0
};
static struct raster font_fixed_23 = { 6, 13, 1, 1, font_fixed_23_pixels, 0 };

static u_int32_t font_fixed_24_pixels[] = {
	0,0,0,0,0,0,0,0xfc000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000
};
static struct raster font_fixed_24 = { 6, 13, 1, 1, font_fixed_24_pixels, 0 };

static u_int32_t font_fixed_25_pixels[] = {
	0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000
};
static struct raster font_fixed_25 = { 6, 13, 1, 1, font_fixed_25_pixels, 0 };

static u_int32_t font_fixed_26_pixels[] = {
	0,0,0,0x8000000,0x10000000,0x20000000,0x40000000,0x20000000,0x10000000,0x8000000,0xf8000000,0,0
};
static struct raster font_fixed_26 = { 6, 13, 1, 1, font_fixed_26_pixels, 0 };

static u_int32_t font_fixed_27_pixels[] = {
	0,0,0,0x80000000,0x40000000,0x20000000,0x10000000,0x20000000,0x40000000,0x80000000,0xf8000000,0,0
};
static struct raster font_fixed_27 = { 6, 13, 1, 1, font_fixed_27_pixels, 0 };

static u_int32_t font_fixed_28_pixels[] = {
	0,0,0,0,0,0,0xf8000000,0x50000000,0x50000000,0x50000000,0x90000000,0,0
};
static struct raster font_fixed_28 = { 6, 13, 1, 1, font_fixed_28_pixels, 0 };

static u_int32_t font_fixed_29_pixels[] = {
	0,0,0,0,0,0x8000000,0xf8000000,0x20000000,0xf8000000,0x80000000,0,0,0
};
static struct raster font_fixed_29 = { 6, 13, 1, 1, font_fixed_29_pixels, 0 };

static u_int32_t font_fixed_30_pixels[] = {
	0,0,0,0,0x30000000,0x48000000,0x40000000,0xf0000000,0x20000000,0xf0000000,0xa8000000,0xe0000000,0
};
static struct raster font_fixed_30 = { 6, 13, 1, 1, font_fixed_30_pixels, 0 };

static u_int32_t font_fixed_31_pixels[] = {
	0,0,0,0,0,0,0,0,0x20000000,0,0,0,0
};
static struct raster font_fixed_31 = { 6, 13, 1, 1, font_fixed_31_pixels, 0 };

static u_int32_t font_fixed_32_pixels[] = {
	0,0,0,0,0,0,0,0,0,0,0,0,0
};
static struct raster font_fixed_32 = { 6, 13, 1, 1, font_fixed_32_pixels, 0 };

static u_int32_t font_fixed_33_pixels[] = {
	0,0,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0,0x20000000,0,0
};
static struct raster font_fixed_33 = { 6, 13, 1, 1, font_fixed_33_pixels, 0 };

static u_int32_t font_fixed_34_pixels[] = {
	0,0,0x50000000,0x50000000,0x50000000,0,0,0,0,0,0,0,0
};
static struct raster font_fixed_34 = { 6, 13, 1, 1, font_fixed_34_pixels, 0 };

static u_int32_t font_fixed_35_pixels[] = {
	0,0,0,0x50000000,0x50000000,0xf8000000,0x50000000,0xf8000000,0x50000000,0x50000000,0,0,0
};
static struct raster font_fixed_35 = { 6, 13, 1, 1, font_fixed_35_pixels, 0 };

static u_int32_t font_fixed_36_pixels[] = {
	0,0x20000000,0x70000000,0xa0000000,0xa0000000,0x70000000,0x28000000,0x28000000,0x70000000,0x20000000,0,0,0
};
static struct raster font_fixed_36 = { 6, 13, 1, 1, font_fixed_36_pixels, 0 };

static u_int32_t font_fixed_37_pixels[] = {
	0,0,0x48000000,0xa8000000,0x50000000,0x10000000,0x20000000,0x40000000,0x50000000,0xa8000000,0x90000000,0,0
};
static struct raster font_fixed_37 = { 6, 13, 1, 1, font_fixed_37_pixels, 0 };

static u_int32_t font_fixed_38_pixels[] = {
	0,0,0x40000000,0xa0000000,0xa0000000,0x40000000,0xa0000000,0x98000000,0x90000000,0x68000000,0,0,0
};
static struct raster font_fixed_38 = { 6, 13, 1, 1, font_fixed_38_pixels, 0 };

static u_int32_t font_fixed_39_pixels[] = {
	0,0,0x30000000,0x20000000,0x40000000,0,0,0,0,0,0,0,0
};
static struct raster font_fixed_39 = { 6, 13, 1, 1, font_fixed_39_pixels, 0 };

static u_int32_t font_fixed_40_pixels[] = {
	0,0,0x10000000,0x20000000,0x20000000,0x40000000,0x40000000,0x40000000,0x20000000,0x20000000,0x10000000,0,0
};
static struct raster font_fixed_40 = { 6, 13, 1, 1, font_fixed_40_pixels, 0 };

static u_int32_t font_fixed_41_pixels[] = {
	0,0,0x40000000,0x20000000,0x20000000,0x10000000,0x10000000,0x10000000,0x20000000,0x20000000,0x40000000,0,0
};
static struct raster font_fixed_41 = { 6, 13, 1, 1, font_fixed_41_pixels, 0 };

static u_int32_t font_fixed_42_pixels[] = {
	0,0,0,0x20000000,0xa8000000,0xf8000000,0x70000000,0xf8000000,0xa8000000,0x20000000,0,0,0
};
static struct raster font_fixed_42 = { 6, 13, 1, 1, font_fixed_42_pixels, 0 };

static u_int32_t font_fixed_43_pixels[] = {
	0,0,0,0,0x20000000,0x20000000,0xf8000000,0x20000000,0x20000000,0,0,0,0
};
static struct raster font_fixed_43 = { 6, 13, 1, 1, font_fixed_43_pixels, 0 };

static u_int32_t font_fixed_44_pixels[] = {
	0,0,0,0,0,0,0,0,0,0x30000000,0x20000000,0x40000000,0
};
static struct raster font_fixed_44 = { 6, 13, 1, 1, font_fixed_44_pixels, 0 };

static u_int32_t font_fixed_45_pixels[] = {
	0,0,0,0,0,0,0xf8000000,0,0,0,0,0,0
};
static struct raster font_fixed_45 = { 6, 13, 1, 1, font_fixed_45_pixels, 0 };

static u_int32_t font_fixed_46_pixels[] = {
	0,0,0,0,0,0,0,0,0,0x20000000,0x70000000,0x20000000,0
};
static struct raster font_fixed_46 = { 6, 13, 1, 1, font_fixed_46_pixels, 0 };

static u_int32_t font_fixed_47_pixels[] = {
	0,0,0x8000000,0x8000000,0x10000000,0x10000000,0x20000000,0x40000000,0x40000000,0x80000000,0x80000000,0,0
};
static struct raster font_fixed_47 = { 6, 13, 1, 1, font_fixed_47_pixels, 0 };

static u_int32_t font_fixed_48_pixels[] = {
	0,0,0x20000000,0x50000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x50000000,0x20000000,0,0
};
static struct raster font_fixed_48 = { 6, 13, 1, 1, font_fixed_48_pixels, 0 };

static u_int32_t font_fixed_49_pixels[] = {
	0,0,0x20000000,0x60000000,0xa0000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0xf8000000,0,0
};
static struct raster font_fixed_49 = { 6, 13, 1, 1, font_fixed_49_pixels, 0 };

static u_int32_t font_fixed_50_pixels[] = {
	0,0,0x70000000,0x88000000,0x88000000,0x8000000,0x10000000,0x20000000,0x40000000,0x80000000,0xf8000000,0,0
};
static struct raster font_fixed_50 = { 6, 13, 1, 1, font_fixed_50_pixels, 0 };

static u_int32_t font_fixed_51_pixels[] = {
	0,0,0xf8000000,0x8000000,0x10000000,0x20000000,0x70000000,0x8000000,0x8000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_51 = { 6, 13, 1, 1, font_fixed_51_pixels, 0 };

static u_int32_t font_fixed_52_pixels[] = {
	0,0,0x10000000,0x10000000,0x30000000,0x50000000,0x50000000,0x90000000,0xf8000000,0x10000000,0x10000000,0,0
};
static struct raster font_fixed_52 = { 6, 13, 1, 1, font_fixed_52_pixels, 0 };

static u_int32_t font_fixed_53_pixels[] = {
	0,0,0xf8000000,0x80000000,0x80000000,0xb0000000,0xc8000000,0x8000000,0x8000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_53 = { 6, 13, 1, 1, font_fixed_53_pixels, 0 };

static u_int32_t font_fixed_54_pixels[] = {
	0,0,0x70000000,0x88000000,0x80000000,0x80000000,0xf0000000,0x88000000,0x88000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_54 = { 6, 13, 1, 1, font_fixed_54_pixels, 0 };

static u_int32_t font_fixed_55_pixels[] = {
	0,0,0xf8000000,0x8000000,0x10000000,0x10000000,0x20000000,0x20000000,0x40000000,0x40000000,0x40000000,0,0
};
static struct raster font_fixed_55 = { 6, 13, 1, 1, font_fixed_55_pixels, 0 };

static u_int32_t font_fixed_56_pixels[] = {
	0,0,0x70000000,0x88000000,0x88000000,0x88000000,0x70000000,0x88000000,0x88000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_56 = { 6, 13, 1, 1, font_fixed_56_pixels, 0 };

static u_int32_t font_fixed_57_pixels[] = {
	0,0,0x70000000,0x88000000,0x88000000,0x88000000,0x78000000,0x8000000,0x8000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_57 = { 6, 13, 1, 1, font_fixed_57_pixels, 0 };

static u_int32_t font_fixed_58_pixels[] = {
	0,0,0,0,0x20000000,0x70000000,0x20000000,0,0,0x20000000,0x70000000,0x20000000,0
};
static struct raster font_fixed_58 = { 6, 13, 1, 1, font_fixed_58_pixels, 0 };

static u_int32_t font_fixed_59_pixels[] = {
	0,0,0,0,0x20000000,0x70000000,0x20000000,0,0,0x30000000,0x20000000,0x40000000,0
};
static struct raster font_fixed_59 = { 6, 13, 1, 1, font_fixed_59_pixels, 0 };

static u_int32_t font_fixed_60_pixels[] = {
	0,0,0x8000000,0x10000000,0x20000000,0x40000000,0x80000000,0x40000000,0x20000000,0x10000000,0x8000000,0,0
};
static struct raster font_fixed_60 = { 6, 13, 1, 1, font_fixed_60_pixels, 0 };

static u_int32_t font_fixed_61_pixels[] = {
	0,0,0,0,0,0xf8000000,0,0,0xf8000000,0,0,0,0
};
static struct raster font_fixed_61 = { 6, 13, 1, 1, font_fixed_61_pixels, 0 };

static u_int32_t font_fixed_62_pixels[] = {
	0,0,0x80000000,0x40000000,0x20000000,0x10000000,0x8000000,0x10000000,0x20000000,0x40000000,0x80000000,0,0
};
static struct raster font_fixed_62 = { 6, 13, 1, 1, font_fixed_62_pixels, 0 };

static u_int32_t font_fixed_63_pixels[] = {
	0,0,0x70000000,0x88000000,0x88000000,0x8000000,0x10000000,0x20000000,0x20000000,0,0x20000000,0,0
};
static struct raster font_fixed_63 = { 6, 13, 1, 1, font_fixed_63_pixels, 0 };

static u_int32_t font_fixed_64_pixels[] = {
	0,0,0x70000000,0x88000000,0x88000000,0x98000000,0xa8000000,0xa8000000,0xb0000000,0x80000000,0x78000000,0,0
};
static struct raster font_fixed_64 = { 6, 13, 1, 1, font_fixed_64_pixels, 0 };

static u_int32_t font_fixed_65_pixels[] = {
	0,0,0x20000000,0x50000000,0x88000000,0x88000000,0x88000000,0xf8000000,0x88000000,0x88000000,0x88000000,0,0
};
static struct raster font_fixed_65 = { 6, 13, 1, 1, font_fixed_65_pixels, 0 };

static u_int32_t font_fixed_66_pixels[] = {
	0,0,0xf0000000,0x48000000,0x48000000,0x48000000,0x70000000,0x48000000,0x48000000,0x48000000,0xf0000000,0,0
};
static struct raster font_fixed_66 = { 6, 13, 1, 1, font_fixed_66_pixels, 0 };

static u_int32_t font_fixed_67_pixels[] = {
	0,0,0x70000000,0x88000000,0x80000000,0x80000000,0x80000000,0x80000000,0x80000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_67 = { 6, 13, 1, 1, font_fixed_67_pixels, 0 };

static u_int32_t font_fixed_68_pixels[] = {
	0,0,0xf0000000,0x48000000,0x48000000,0x48000000,0x48000000,0x48000000,0x48000000,0x48000000,0xf0000000,0,0
};
static struct raster font_fixed_68 = { 6, 13, 1, 1, font_fixed_68_pixels, 0 };

static u_int32_t font_fixed_69_pixels[] = {
	0,0,0xf8000000,0x80000000,0x80000000,0x80000000,0xf0000000,0x80000000,0x80000000,0x80000000,0xf8000000,0,0
};
static struct raster font_fixed_69 = { 6, 13, 1, 1, font_fixed_69_pixels, 0 };

static u_int32_t font_fixed_70_pixels[] = {
	0,0,0xf8000000,0x80000000,0x80000000,0x80000000,0xf0000000,0x80000000,0x80000000,0x80000000,0x80000000,0,0
};
static struct raster font_fixed_70 = { 6, 13, 1, 1, font_fixed_70_pixels, 0 };

static u_int32_t font_fixed_71_pixels[] = {
	0,0,0x70000000,0x88000000,0x80000000,0x80000000,0x80000000,0x98000000,0x88000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_71 = { 6, 13, 1, 1, font_fixed_71_pixels, 0 };

static u_int32_t font_fixed_72_pixels[] = {
	0,0,0x88000000,0x88000000,0x88000000,0x88000000,0xf8000000,0x88000000,0x88000000,0x88000000,0x88000000,0,0
};
static struct raster font_fixed_72 = { 6, 13, 1, 1, font_fixed_72_pixels, 0 };

static u_int32_t font_fixed_73_pixels[] = {
	0,0,0x70000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x70000000,0,0
};
static struct raster font_fixed_73 = { 6, 13, 1, 1, font_fixed_73_pixels, 0 };

static u_int32_t font_fixed_74_pixels[] = {
	0,0,0x38000000,0x10000000,0x10000000,0x10000000,0x10000000,0x10000000,0x10000000,0x90000000,0x60000000,0,0
};
static struct raster font_fixed_74 = { 6, 13, 1, 1, font_fixed_74_pixels, 0 };

static u_int32_t font_fixed_75_pixels[] = {
	0,0,0x88000000,0x88000000,0x90000000,0xa0000000,0xc0000000,0xa0000000,0x90000000,0x88000000,0x88000000,0,0
};
static struct raster font_fixed_75 = { 6, 13, 1, 1, font_fixed_75_pixels, 0 };

static u_int32_t font_fixed_76_pixels[] = {
	0,0,0x80000000,0x80000000,0x80000000,0x80000000,0x80000000,0x80000000,0x80000000,0x80000000,0xf8000000,0,0
};
static struct raster font_fixed_76 = { 6, 13, 1, 1, font_fixed_76_pixels, 0 };

static u_int32_t font_fixed_77_pixels[] = {
	0,0,0x88000000,0x88000000,0xd8000000,0xa8000000,0xa8000000,0x88000000,0x88000000,0x88000000,0x88000000,0,0
};
static struct raster font_fixed_77 = { 6, 13, 1, 1, font_fixed_77_pixels, 0 };

static u_int32_t font_fixed_78_pixels[] = {
	0,0,0x88000000,0xc8000000,0xc8000000,0xa8000000,0xa8000000,0x98000000,0x98000000,0x88000000,0x88000000,0,0
};
static struct raster font_fixed_78 = { 6, 13, 1, 1, font_fixed_78_pixels, 0 };

static u_int32_t font_fixed_79_pixels[] = {
	0,0,0x70000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_79 = { 6, 13, 1, 1, font_fixed_79_pixels, 0 };

static u_int32_t font_fixed_80_pixels[] = {
	0,0,0xf0000000,0x88000000,0x88000000,0x88000000,0xf0000000,0x80000000,0x80000000,0x80000000,0x80000000,0,0
};
static struct raster font_fixed_80 = { 6, 13, 1, 1, font_fixed_80_pixels, 0 };

static u_int32_t font_fixed_81_pixels[] = {
	0,0,0x70000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0xa8000000,0x70000000,0x8000000,0
};
static struct raster font_fixed_81 = { 6, 13, 1, 1, font_fixed_81_pixels, 0 };

static u_int32_t font_fixed_82_pixels[] = {
	0,0,0xf0000000,0x88000000,0x88000000,0x88000000,0xf0000000,0xa0000000,0x90000000,0x88000000,0x88000000,0,0
};
static struct raster font_fixed_82 = { 6, 13, 1, 1, font_fixed_82_pixels, 0 };

static u_int32_t font_fixed_83_pixels[] = {
	0,0,0x70000000,0x88000000,0x80000000,0x80000000,0x70000000,0x8000000,0x8000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_83 = { 6, 13, 1, 1, font_fixed_83_pixels, 0 };

static u_int32_t font_fixed_84_pixels[] = {
	0,0,0xf8000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0,0
};
static struct raster font_fixed_84 = { 6, 13, 1, 1, font_fixed_84_pixels, 0 };

static u_int32_t font_fixed_85_pixels[] = {
	0,0,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_85 = { 6, 13, 1, 1, font_fixed_85_pixels, 0 };

static u_int32_t font_fixed_86_pixels[] = {
	0,0,0x88000000,0x88000000,0x88000000,0x88000000,0x50000000,0x50000000,0x50000000,0x20000000,0x20000000,0,0
};
static struct raster font_fixed_86 = { 6, 13, 1, 1, font_fixed_86_pixels, 0 };

static u_int32_t font_fixed_87_pixels[] = {
	0,0,0x88000000,0x88000000,0x88000000,0x88000000,0xa8000000,0xa8000000,0xa8000000,0xd8000000,0x88000000,0,0
};
static struct raster font_fixed_87 = { 6, 13, 1, 1, font_fixed_87_pixels, 0 };

static u_int32_t font_fixed_88_pixels[] = {
	0,0,0x88000000,0x88000000,0x50000000,0x50000000,0x20000000,0x50000000,0x50000000,0x88000000,0x88000000,0,0
};
static struct raster font_fixed_88 = { 6, 13, 1, 1, font_fixed_88_pixels, 0 };

static u_int32_t font_fixed_89_pixels[] = {
	0,0,0x88000000,0x88000000,0x50000000,0x50000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0,0
};
static struct raster font_fixed_89 = { 6, 13, 1, 1, font_fixed_89_pixels, 0 };

static u_int32_t font_fixed_90_pixels[] = {
	0,0,0xf8000000,0x8000000,0x10000000,0x10000000,0x20000000,0x40000000,0x40000000,0x80000000,0xf8000000,0,0
};
static struct raster font_fixed_90 = { 6, 13, 1, 1, font_fixed_90_pixels, 0 };

static u_int32_t font_fixed_91_pixels[] = {
	0,0,0x70000000,0x40000000,0x40000000,0x40000000,0x40000000,0x40000000,0x40000000,0x40000000,0x70000000,0,0
};
static struct raster font_fixed_91 = { 6, 13, 1, 1, font_fixed_91_pixels, 0 };

static u_int32_t font_fixed_92_pixels[] = {
	0,0,0x80000000,0x80000000,0x40000000,0x40000000,0x20000000,0x10000000,0x10000000,0x8000000,0x8000000,0,0
};
static struct raster font_fixed_92 = { 6, 13, 1, 1, font_fixed_92_pixels, 0 };

static u_int32_t font_fixed_93_pixels[] = {
	0,0,0x70000000,0x10000000,0x10000000,0x10000000,0x10000000,0x10000000,0x10000000,0x10000000,0x70000000,0,0
};
static struct raster font_fixed_93 = { 6, 13, 1, 1, font_fixed_93_pixels, 0 };

static u_int32_t font_fixed_94_pixels[] = {
	0,0,0x20000000,0x50000000,0x88000000,0,0,0,0,0,0,0,0
};
static struct raster font_fixed_94 = { 6, 13, 1, 1, font_fixed_94_pixels, 0 };

static u_int32_t font_fixed_95_pixels[] = {
	0,0,0,0,0,0,0,0,0,0,0,0xf8000000,0
};
static struct raster font_fixed_95 = { 6, 13, 1, 1, font_fixed_95_pixels, 0 };

static u_int32_t font_fixed_96_pixels[] = {
	0,0,0x30000000,0x10000000,0x8000000,0,0,0,0,0,0,0,0
};
static struct raster font_fixed_96 = { 6, 13, 1, 1, font_fixed_96_pixels, 0 };

static u_int32_t font_fixed_97_pixels[] = {
	0,0,0,0,0,0x70000000,0x8000000,0x78000000,0x88000000,0x88000000,0x78000000,0,0
};
static struct raster font_fixed_97 = { 6, 13, 1, 1, font_fixed_97_pixels, 0 };

static u_int32_t font_fixed_98_pixels[] = {
	0,0,0x80000000,0x80000000,0x80000000,0xf0000000,0x88000000,0x88000000,0x88000000,0x88000000,0xf0000000,0,0
};
static struct raster font_fixed_98 = { 6, 13, 1, 1, font_fixed_98_pixels, 0 };

static u_int32_t font_fixed_99_pixels[] = {
	0,0,0,0,0,0x70000000,0x88000000,0x80000000,0x80000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_99 = { 6, 13, 1, 1, font_fixed_99_pixels, 0 };

static u_int32_t font_fixed_100_pixels[] = {
	0,0,0x8000000,0x8000000,0x8000000,0x78000000,0x88000000,0x88000000,0x88000000,0x88000000,0x78000000,0,0
};
static struct raster font_fixed_100 = { 6, 13, 1, 1, font_fixed_100_pixels, 0 };

static u_int32_t font_fixed_101_pixels[] = {
	0,0,0,0,0,0x70000000,0x88000000,0xf8000000,0x80000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_101 = { 6, 13, 1, 1, font_fixed_101_pixels, 0 };

static u_int32_t font_fixed_102_pixels[] = {
	0,0,0x30000000,0x48000000,0x40000000,0x40000000,0xf0000000,0x40000000,0x40000000,0x40000000,0x40000000,0,0
};
static struct raster font_fixed_102 = { 6, 13, 1, 1, font_fixed_102_pixels, 0 };

static u_int32_t font_fixed_103_pixels[] = {
	0,0,0,0,0,0x70000000,0x88000000,0x88000000,0x88000000,0x78000000,0x8000000,0x88000000,0x70000000
};
static struct raster font_fixed_103 = { 6, 13, 1, 1, font_fixed_103_pixels, 0 };

static u_int32_t font_fixed_104_pixels[] = {
	0,0,0x80000000,0x80000000,0x80000000,0xb0000000,0xc8000000,0x88000000,0x88000000,0x88000000,0x88000000,0,0
};
static struct raster font_fixed_104 = { 6, 13, 1, 1, font_fixed_104_pixels, 0 };

static u_int32_t font_fixed_105_pixels[] = {
	0,0,0,0x20000000,0,0x60000000,0x20000000,0x20000000,0x20000000,0x20000000,0x70000000,0,0
};
static struct raster font_fixed_105 = { 6, 13, 1, 1, font_fixed_105_pixels, 0 };

static u_int32_t font_fixed_106_pixels[] = {
	0,0,0,0x10000000,0,0x30000000,0x10000000,0x10000000,0x10000000,0x10000000,0x90000000,0x90000000,0x60000000
};
static struct raster font_fixed_106 = { 6, 13, 1, 1, font_fixed_106_pixels, 0 };

static u_int32_t font_fixed_107_pixels[] = {
	0,0,0x80000000,0x80000000,0x80000000,0x90000000,0xa0000000,0xc0000000,0xa0000000,0x90000000,0x88000000,0,0
};
static struct raster font_fixed_107 = { 6, 13, 1, 1, font_fixed_107_pixels, 0 };

static u_int32_t font_fixed_108_pixels[] = {
	0,0,0x60000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x70000000,0,0
};
static struct raster font_fixed_108 = { 6, 13, 1, 1, font_fixed_108_pixels, 0 };

static u_int32_t font_fixed_109_pixels[] = {
	0,0,0,0,0,0xd0000000,0xa8000000,0xa8000000,0xa8000000,0xa8000000,0x88000000,0,0
};
static struct raster font_fixed_109 = { 6, 13, 1, 1, font_fixed_109_pixels, 0 };

static u_int32_t font_fixed_110_pixels[] = {
	0,0,0,0,0,0xb0000000,0xc8000000,0x88000000,0x88000000,0x88000000,0x88000000,0,0
};
static struct raster font_fixed_110 = { 6, 13, 1, 1, font_fixed_110_pixels, 0 };

static u_int32_t font_fixed_111_pixels[] = {
	0,0,0,0,0,0x70000000,0x88000000,0x88000000,0x88000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_111 = { 6, 13, 1, 1, font_fixed_111_pixels, 0 };

static u_int32_t font_fixed_112_pixels[] = {
	0,0,0,0,0,0xf0000000,0x88000000,0x88000000,0x88000000,0xf0000000,0x80000000,0x80000000,0x80000000
};
static struct raster font_fixed_112 = { 6, 13, 1, 1, font_fixed_112_pixels, 0 };

static u_int32_t font_fixed_113_pixels[] = {
	0,0,0,0,0,0x78000000,0x88000000,0x88000000,0x88000000,0x78000000,0x8000000,0x8000000,0x8000000
};
static struct raster font_fixed_113 = { 6, 13, 1, 1, font_fixed_113_pixels, 0 };

static u_int32_t font_fixed_114_pixels[] = {
	0,0,0,0,0,0xb0000000,0xc8000000,0x80000000,0x80000000,0x80000000,0x80000000,0,0
};
static struct raster font_fixed_114 = { 6, 13, 1, 1, font_fixed_114_pixels, 0 };

static u_int32_t font_fixed_115_pixels[] = {
	0,0,0,0,0,0x70000000,0x88000000,0x60000000,0x10000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_115 = { 6, 13, 1, 1, font_fixed_115_pixels, 0 };

static u_int32_t font_fixed_116_pixels[] = {
	0,0,0,0x40000000,0x40000000,0xf0000000,0x40000000,0x40000000,0x40000000,0x48000000,0x30000000,0,0
};
static struct raster font_fixed_116 = { 6, 13, 1, 1, font_fixed_116_pixels, 0 };

static u_int32_t font_fixed_117_pixels[] = {
	0,0,0,0,0,0x88000000,0x88000000,0x88000000,0x88000000,0x98000000,0x68000000,0,0
};
static struct raster font_fixed_117 = { 6, 13, 1, 1, font_fixed_117_pixels, 0 };

static u_int32_t font_fixed_118_pixels[] = {
	0,0,0,0,0,0x88000000,0x88000000,0x88000000,0x50000000,0x50000000,0x20000000,0,0
};
static struct raster font_fixed_118 = { 6, 13, 1, 1, font_fixed_118_pixels, 0 };

static u_int32_t font_fixed_119_pixels[] = {
	0,0,0,0,0,0x88000000,0x88000000,0xa8000000,0xa8000000,0xa8000000,0x50000000,0,0
};
static struct raster font_fixed_119 = { 6, 13, 1, 1, font_fixed_119_pixels, 0 };

static u_int32_t font_fixed_120_pixels[] = {
	0,0,0,0,0,0x88000000,0x50000000,0x20000000,0x20000000,0x50000000,0x88000000,0,0
};
static struct raster font_fixed_120 = { 6, 13, 1, 1, font_fixed_120_pixels, 0 };

static u_int32_t font_fixed_121_pixels[] = {
	0,0,0,0,0,0x88000000,0x88000000,0x88000000,0x98000000,0x68000000,0x8000000,0x88000000,0x70000000
};
static struct raster font_fixed_121 = { 6, 13, 1, 1, font_fixed_121_pixels, 0 };

static u_int32_t font_fixed_122_pixels[] = {
	0,0,0,0,0,0xf8000000,0x10000000,0x20000000,0x40000000,0x80000000,0xf8000000,0,0
};
static struct raster font_fixed_122 = { 6, 13, 1, 1, font_fixed_122_pixels, 0 };

static u_int32_t font_fixed_123_pixels[] = {
	0,0,0x18000000,0x20000000,0x20000000,0x20000000,0xc0000000,0x20000000,0x20000000,0x20000000,0x18000000,0,0
};
static struct raster font_fixed_123 = { 6, 13, 1, 1, font_fixed_123_pixels, 0 };

static u_int32_t font_fixed_124_pixels[] = {
	0,0,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0,0
};
static struct raster font_fixed_124 = { 6, 13, 1, 1, font_fixed_124_pixels, 0 };

static u_int32_t font_fixed_125_pixels[] = {
	0,0,0xc0000000,0x20000000,0x20000000,0x20000000,0x18000000,0x20000000,0x20000000,0x20000000,0xc0000000,0,0
};
static struct raster font_fixed_125 = { 6, 13, 1, 1, font_fixed_125_pixels, 0 };

static u_int32_t font_fixed_126_pixels[] = {
	0,0,0x48000000,0xa8000000,0x90000000,0,0,0,0,0,0,0,0
};
static struct raster font_fixed_126 = { 6, 13, 1, 1, font_fixed_126_pixels, 0 };

static u_int32_t font_fixed_127_pixels[] = {
	0xa8000000,0x50000000,0xa8000000,0x50000000,0xa8000000,0x50000000,0xa8000000,0x50000000,0xa8000000,0x50000000,0xa8000000,0x50000000,0xa8000000
};
static struct raster font_fixed_127 = { 6, 13, 1, 1, font_fixed_127_pixels, 0 };

static u_int32_t font_fixed_160_pixels[] = {
	0,0,0,0,0,0,0,0,0,0,0,0,0
};
static struct raster font_fixed_160 = { 6, 13, 1, 1, font_fixed_160_pixels, 0 };

static u_int32_t font_fixed_161_pixels[] = {
	0,0,0,0,0x20000000,0,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000
};
static struct raster font_fixed_161 = { 6, 13, 1, 1, font_fixed_161_pixels, 0 };

static u_int32_t font_fixed_162_pixels[] = {
	0,0,0x20000000,0x20000000,0x70000000,0x88000000,0x80000000,0x88000000,0x70000000,0x20000000,0x20000000,0,0
};
static struct raster font_fixed_162 = { 6, 13, 1, 1, font_fixed_162_pixels, 0 };

static u_int32_t font_fixed_163_pixels[] = {
	0,0,0x30000000,0x48000000,0x40000000,0x40000000,0xf0000000,0x40000000,0x40000000,0x88000000,0xf0000000,0,0
};
static struct raster font_fixed_163 = { 6, 13, 1, 1, font_fixed_163_pixels, 0 };

static u_int32_t font_fixed_164_pixels[] = {
	0,0,0,0xa8000000,0x50000000,0x88000000,0x88000000,0x50000000,0xa8000000,0,0,0,0
};
static struct raster font_fixed_164 = { 6, 13, 1, 1, font_fixed_164_pixels, 0 };

static u_int32_t font_fixed_165_pixels[] = {
	0,0,0x88000000,0x88000000,0x50000000,0x50000000,0x20000000,0xf8000000,0x20000000,0xf8000000,0x20000000,0,0
};
static struct raster font_fixed_165 = { 6, 13, 1, 1, font_fixed_165_pixels, 0 };

static u_int32_t font_fixed_166_pixels[] = {
	0,0,0x20000000,0x20000000,0x20000000,0x20000000,0,0x20000000,0x20000000,0x20000000,0x20000000,0,0
};
static struct raster font_fixed_166 = { 6, 13, 1, 1, font_fixed_166_pixels, 0 };

static u_int32_t font_fixed_167_pixels[] = {
	0,0,0x70000000,0x88000000,0x80000000,0x70000000,0x88000000,0x88000000,0x70000000,0x8000000,0x88000000,0x70000000,0
};
static struct raster font_fixed_167 = { 6, 13, 1, 1, font_fixed_167_pixels, 0 };

static u_int32_t font_fixed_168_pixels[] = {
	0,0x50000000,0,0,0,0,0,0,0,0,0,0,0
};
static struct raster font_fixed_168 = { 6, 13, 1, 1, font_fixed_168_pixels, 0 };

static u_int32_t font_fixed_169_pixels[] = {
	0,0,0x70000000,0x88000000,0xa8000000,0xd8000000,0xc8000000,0xd8000000,0xa8000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_169 = { 6, 13, 1, 1, font_fixed_169_pixels, 0 };

static u_int32_t font_fixed_170_pixels[] = {
	0,0,0,0x60000000,0x90000000,0x70000000,0x90000000,0xe8000000,0,0xf8000000,0,0,0
};
static struct raster font_fixed_170 = { 6, 13, 1, 1, font_fixed_170_pixels, 0 };

static u_int32_t font_fixed_171_pixels[] = {
	0,0,0,0,0,0,0x28000000,0x50000000,0xa0000000,0x50000000,0x28000000,0,0
};
static struct raster font_fixed_171 = { 6, 13, 1, 1, font_fixed_171_pixels, 0 };

static u_int32_t font_fixed_172_pixels[] = {
	0,0,0,0,0,0,0xf8000000,0x8000000,0x8000000,0,0,0,0
};
static struct raster font_fixed_172 = { 6, 13, 1, 1, font_fixed_172_pixels, 0 };

static u_int32_t font_fixed_173_pixels[] = {
	0,0,0,0,0,0,0x78000000,0,0,0,0,0,0
};
static struct raster font_fixed_173 = { 6, 13, 1, 1, font_fixed_173_pixels, 0 };

static u_int32_t font_fixed_174_pixels[] = {
	0,0,0x70000000,0x88000000,0xe8000000,0xd8000000,0xe8000000,0xd8000000,0xd8000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_174 = { 6, 13, 1, 1, font_fixed_174_pixels, 0 };

static u_int32_t font_fixed_175_pixels[] = {
	0,0,0x70000000,0,0,0,0,0,0,0,0,0,0
};
static struct raster font_fixed_175 = { 6, 13, 1, 1, font_fixed_175_pixels, 0 };

static u_int32_t font_fixed_176_pixels[] = {
	0,0,0x60000000,0x90000000,0x90000000,0x60000000,0,0,0,0,0,0,0
};
static struct raster font_fixed_176 = { 6, 13, 1, 1, font_fixed_176_pixels, 0 };

static u_int32_t font_fixed_177_pixels[] = {
	0,0,0,0,0x20000000,0x20000000,0xf8000000,0x20000000,0x20000000,0,0xf8000000,0,0
};
static struct raster font_fixed_177 = { 6, 13, 1, 1, font_fixed_177_pixels, 0 };

static u_int32_t font_fixed_178_pixels[] = {
	0,0x60000000,0x90000000,0x90000000,0x20000000,0x40000000,0xf0000000,0,0,0,0,0,0
};
static struct raster font_fixed_178 = { 6, 13, 1, 1, font_fixed_178_pixels, 0 };

static u_int32_t font_fixed_179_pixels[] = {
	0,0x60000000,0x90000000,0x20000000,0x10000000,0x90000000,0x60000000,0,0,0,0,0,0
};
static struct raster font_fixed_179 = { 6, 13, 1, 1, font_fixed_179_pixels, 0 };

static u_int32_t font_fixed_180_pixels[] = {
	0,0x18000000,0x60000000,0,0,0,0,0,0,0,0,0,0
};
static struct raster font_fixed_180 = { 6, 13, 1, 1, font_fixed_180_pixels, 0 };

static u_int32_t font_fixed_181_pixels[] = {
	0,0,0,0,0,0x88000000,0x88000000,0x88000000,0x88000000,0x98000000,0xe8000000,0x80000000,0x80000000
};
static struct raster font_fixed_181 = { 6, 13, 1, 1, font_fixed_181_pixels, 0 };

static u_int32_t font_fixed_182_pixels[] = {
	0,0x78000000,0xa8000000,0xa8000000,0xa8000000,0x68000000,0x28000000,0x28000000,0x28000000,0x28000000,0x28000000,0,0
};
static struct raster font_fixed_182 = { 6, 13, 1, 1, font_fixed_182_pixels, 0 };

static u_int32_t font_fixed_183_pixels[] = {
	0,0,0,0,0,0x20000000,0x70000000,0x20000000,0,0,0,0,0
};
static struct raster font_fixed_183 = { 6, 13, 1, 1, font_fixed_183_pixels, 0 };

static u_int32_t font_fixed_184_pixels[] = {
	0,0,0,0,0,0,0,0,0,0,0,0x10000000,0x30000000
};
static struct raster font_fixed_184 = { 6, 13, 1, 1, font_fixed_184_pixels, 0 };

static u_int32_t font_fixed_185_pixels[] = {
	0,0x20000000,0x60000000,0x20000000,0x20000000,0x20000000,0x70000000,0,0,0,0,0,0
};
static struct raster font_fixed_185 = { 6, 13, 1, 1, font_fixed_185_pixels, 0 };

static u_int32_t font_fixed_186_pixels[] = {
	0,0,0,0x70000000,0x88000000,0x88000000,0x88000000,0x70000000,0,0xf8000000,0,0,0
};
static struct raster font_fixed_186 = { 6, 13, 1, 1, font_fixed_186_pixels, 0 };

static u_int32_t font_fixed_187_pixels[] = {
	0,0,0,0,0,0,0xa0000000,0x50000000,0x28000000,0x50000000,0xa0000000,0,0
};
static struct raster font_fixed_187 = { 6, 13, 1, 1, font_fixed_187_pixels, 0 };

static u_int32_t font_fixed_188_pixels[] = {
	0,0x40000000,0xc0000000,0x40000000,0x48000000,0xf0000000,0x38000000,0x38000000,0x68000000,0xbc000000,0x8000000,0,0
};
static struct raster font_fixed_188 = { 6, 13, 1, 1, font_fixed_188_pixels, 0 };

static u_int32_t font_fixed_189_pixels[] = {
	0,0x40000000,0xc0000000,0x40000000,0x48000000,0xf0000000,0x38000000,0x24000000,0x48000000,0x90000000,0x1c000000,0,0
};
static struct raster font_fixed_189 = { 6, 13, 1, 1, font_fixed_189_pixels, 0 };

static u_int32_t font_fixed_190_pixels[] = {
	0,0x60000000,0x90000000,0x20000000,0x98000000,0x70000000,0x38000000,0x38000000,0x68000000,0xbc000000,0x8000000,0,0
};
static struct raster font_fixed_190 = { 6, 13, 1, 1, font_fixed_190_pixels, 0 };

static u_int32_t font_fixed_191_pixels[] = {
	0,0,0,0x20000000,0,0x20000000,0x20000000,0x40000000,0x80000000,0x88000000,0x88000000,0x70000000,0
};
static struct raster font_fixed_191 = { 6, 13, 1, 1, font_fixed_191_pixels, 0 };

static u_int32_t font_fixed_192_pixels[] = {
	0xc0000000,0x30000000,0,0x70000000,0x88000000,0x88000000,0x88000000,0xf8000000,0x88000000,0x88000000,0x88000000,0,0
};
static struct raster font_fixed_192 = { 6, 13, 1, 1, font_fixed_192_pixels, 0 };

static u_int32_t font_fixed_193_pixels[] = {
	0x18000000,0x60000000,0,0x70000000,0x88000000,0x88000000,0x88000000,0xf8000000,0x88000000,0x88000000,0x88000000,0,0
};
static struct raster font_fixed_193 = { 6, 13, 1, 1, font_fixed_193_pixels, 0 };

static u_int32_t font_fixed_194_pixels[] = {
	0x20000000,0x50000000,0,0x70000000,0x88000000,0x88000000,0x88000000,0xf8000000,0x88000000,0x88000000,0x88000000,0,0
};
static struct raster font_fixed_194 = { 6, 13, 1, 1, font_fixed_194_pixels, 0 };

static u_int32_t font_fixed_195_pixels[] = {
	0x68000000,0xb0000000,0x20000000,0x50000000,0x88000000,0x88000000,0x88000000,0xf8000000,0x88000000,0x88000000,0x88000000,0,0
};
static struct raster font_fixed_195 = { 6, 13, 1, 1, font_fixed_195_pixels, 0 };

static u_int32_t font_fixed_196_pixels[] = {
	0x50000000,0,0x20000000,0x50000000,0x88000000,0x88000000,0x88000000,0xf8000000,0x88000000,0x88000000,0x88000000,0,0
};
static struct raster font_fixed_196 = { 6, 13, 1, 1, font_fixed_196_pixels, 0 };

static u_int32_t font_fixed_197_pixels[] = {
	0x20000000,0x50000000,0x20000000,0,0x70000000,0x88000000,0x88000000,0xf8000000,0x88000000,0x88000000,0x88000000,0,0
};
static struct raster font_fixed_197 = { 6, 13, 1, 1, font_fixed_197_pixels, 0 };

static u_int32_t font_fixed_198_pixels[] = {
	0,0,0x3c000000,0x50000000,0x90000000,0x90000000,0x9c000000,0xf0000000,0x90000000,0x90000000,0x9c000000,0,0
};
static struct raster font_fixed_198 = { 6, 13, 1, 1, font_fixed_198_pixels, 0 };

static u_int32_t font_fixed_199_pixels[] = {
	0,0,0x70000000,0x88000000,0x80000000,0x80000000,0x80000000,0x80000000,0x80000000,0x88000000,0x70000000,0x10000000,0x30000000
};
static struct raster font_fixed_199 = { 6, 13, 1, 1, font_fixed_199_pixels, 0 };

static u_int32_t font_fixed_200_pixels[] = {
	0xc0000000,0x30000000,0xf8000000,0x80000000,0x80000000,0x80000000,0xf0000000,0x80000000,0x80000000,0x80000000,0xf8000000,0,0
};
static struct raster font_fixed_200 = { 6, 13, 1, 1, font_fixed_200_pixels, 0 };

static u_int32_t font_fixed_201_pixels[] = {
	0x18000000,0x60000000,0xf8000000,0x80000000,0x80000000,0x80000000,0xf0000000,0x80000000,0x80000000,0x80000000,0xf8000000,0,0
};
static struct raster font_fixed_201 = { 6, 13, 1, 1, font_fixed_201_pixels, 0 };

static u_int32_t font_fixed_202_pixels[] = {
	0x20000000,0x50000000,0xf8000000,0x80000000,0x80000000,0x80000000,0xf0000000,0x80000000,0x80000000,0x80000000,0xf8000000,0,0
};
static struct raster font_fixed_202 = { 6, 13, 1, 1, font_fixed_202_pixels, 0 };

static u_int32_t font_fixed_203_pixels[] = {
	0x50000000,0,0xf8000000,0x80000000,0x80000000,0x80000000,0xf0000000,0x80000000,0x80000000,0x80000000,0xf8000000,0,0
};
static struct raster font_fixed_203 = { 6, 13, 1, 1, font_fixed_203_pixels, 0 };

static u_int32_t font_fixed_204_pixels[] = {
	0xc0000000,0x30000000,0x70000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x70000000,0,0
};
static struct raster font_fixed_204 = { 6, 13, 1, 1, font_fixed_204_pixels, 0 };

static u_int32_t font_fixed_205_pixels[] = {
	0x18000000,0x60000000,0x70000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x70000000,0,0
};
static struct raster font_fixed_205 = { 6, 13, 1, 1, font_fixed_205_pixels, 0 };

static u_int32_t font_fixed_206_pixels[] = {
	0x20000000,0x50000000,0x70000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x70000000,0,0
};
static struct raster font_fixed_206 = { 6, 13, 1, 1, font_fixed_206_pixels, 0 };

static u_int32_t font_fixed_207_pixels[] = {
	0x50000000,0,0x70000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0x70000000,0,0
};
static struct raster font_fixed_207 = { 6, 13, 1, 1, font_fixed_207_pixels, 0 };

static u_int32_t font_fixed_208_pixels[] = {
	0,0,0xf0000000,0x48000000,0x48000000,0x48000000,0xe8000000,0x48000000,0x48000000,0x48000000,0xf0000000,0,0
};
static struct raster font_fixed_208 = { 6, 13, 1, 1, font_fixed_208_pixels, 0 };

static u_int32_t font_fixed_209_pixels[] = {
	0x68000000,0xb0000000,0x88000000,0xc8000000,0xc8000000,0xa8000000,0xa8000000,0x98000000,0x98000000,0x88000000,0x88000000,0,0
};
static struct raster font_fixed_209 = { 6, 13, 1, 1, font_fixed_209_pixels, 0 };

static u_int32_t font_fixed_210_pixels[] = {
	0xc0000000,0x30000000,0,0x70000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_210 = { 6, 13, 1, 1, font_fixed_210_pixels, 0 };

static u_int32_t font_fixed_211_pixels[] = {
	0x18000000,0x60000000,0,0x70000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_211 = { 6, 13, 1, 1, font_fixed_211_pixels, 0 };

static u_int32_t font_fixed_212_pixels[] = {
	0x20000000,0x50000000,0,0x70000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_212 = { 6, 13, 1, 1, font_fixed_212_pixels, 0 };

static u_int32_t font_fixed_213_pixels[] = {
	0x68000000,0xb0000000,0,0x70000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_213 = { 6, 13, 1, 1, font_fixed_213_pixels, 0 };

static u_int32_t font_fixed_214_pixels[] = {
	0x50000000,0,0x70000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_214 = { 6, 13, 1, 1, font_fixed_214_pixels, 0 };

static u_int32_t font_fixed_215_pixels[] = {
	0,0,0,0,0x88000000,0x50000000,0x20000000,0x50000000,0x88000000,0,0,0,0
};
static struct raster font_fixed_215 = { 6, 13, 1, 1, font_fixed_215_pixels, 0 };

static u_int32_t font_fixed_216_pixels[] = {
	0,0,0x78000000,0x98000000,0x98000000,0xa8000000,0xa8000000,0xc8000000,0xc8000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_216 = { 6, 13, 1, 1, font_fixed_216_pixels, 0 };

static u_int32_t font_fixed_217_pixels[] = {
	0xc0000000,0x30000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_217 = { 6, 13, 1, 1, font_fixed_217_pixels, 0 };

static u_int32_t font_fixed_218_pixels[] = {
	0x18000000,0x60000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_218 = { 6, 13, 1, 1, font_fixed_218_pixels, 0 };

static u_int32_t font_fixed_219_pixels[] = {
	0x20000000,0x50000000,0,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_219 = { 6, 13, 1, 1, font_fixed_219_pixels, 0 };

static u_int32_t font_fixed_220_pixels[] = {
	0x50000000,0,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_220 = { 6, 13, 1, 1, font_fixed_220_pixels, 0 };

static u_int32_t font_fixed_221_pixels[] = {
	0x18000000,0x60000000,0x88000000,0x88000000,0x50000000,0x50000000,0x20000000,0x20000000,0x20000000,0x20000000,0x20000000,0,0
};
static struct raster font_fixed_221 = { 6, 13, 1, 1, font_fixed_221_pixels, 0 };

static u_int32_t font_fixed_222_pixels[] = {
	0,0,0x80000000,0x80000000,0xf0000000,0x88000000,0x88000000,0x88000000,0xf0000000,0x80000000,0x80000000,0,0
};
static struct raster font_fixed_222 = { 6, 13, 1, 1, font_fixed_222_pixels, 0 };

static u_int32_t font_fixed_223_pixels[] = {
	0,0,0x60000000,0x90000000,0x90000000,0xa0000000,0xb0000000,0x88000000,0x88000000,0x88000000,0xb0000000,0,0
};
static struct raster font_fixed_223 = { 6, 13, 1, 1, font_fixed_223_pixels, 0 };

static u_int32_t font_fixed_224_pixels[] = {
	0,0,0xc0000000,0x30000000,0,0x70000000,0x8000000,0x78000000,0x88000000,0x88000000,0x78000000,0,0
};
static struct raster font_fixed_224 = { 6, 13, 1, 1, font_fixed_224_pixels, 0 };

static u_int32_t font_fixed_225_pixels[] = {
	0,0,0x18000000,0x60000000,0,0x70000000,0x8000000,0x78000000,0x88000000,0x88000000,0x78000000,0,0
};
static struct raster font_fixed_225 = { 6, 13, 1, 1, font_fixed_225_pixels, 0 };

static u_int32_t font_fixed_226_pixels[] = {
	0,0,0x20000000,0x50000000,0,0x70000000,0x8000000,0x78000000,0x88000000,0x88000000,0x78000000,0,0
};
static struct raster font_fixed_226 = { 6, 13, 1, 1, font_fixed_226_pixels, 0 };

static u_int32_t font_fixed_227_pixels[] = {
	0,0,0x68000000,0xb0000000,0,0x70000000,0x8000000,0x78000000,0x88000000,0x88000000,0x78000000,0,0
};
static struct raster font_fixed_227 = { 6, 13, 1, 1, font_fixed_227_pixels, 0 };

static u_int32_t font_fixed_228_pixels[] = {
	0,0,0,0x50000000,0,0x70000000,0x8000000,0x78000000,0x88000000,0x88000000,0x78000000,0,0
};
static struct raster font_fixed_228 = { 6, 13, 1, 1, font_fixed_228_pixels, 0 };

static u_int32_t font_fixed_229_pixels[] = {
	0,0x20000000,0x50000000,0x20000000,0,0x70000000,0x8000000,0x78000000,0x88000000,0x88000000,0x78000000,0,0
};
static struct raster font_fixed_229 = { 6, 13, 1, 1, font_fixed_229_pixels, 0 };

static u_int32_t font_fixed_230_pixels[] = {
	0,0,0,0,0,0xd0000000,0x28000000,0x78000000,0xa0000000,0xa0000000,0x78000000,0,0
};
static struct raster font_fixed_230 = { 6, 13, 1, 1, font_fixed_230_pixels, 0 };

static u_int32_t font_fixed_231_pixels[] = {
	0,0,0,0,0,0x70000000,0x88000000,0x80000000,0x80000000,0x88000000,0x70000000,0x10000000,0x30000000
};
static struct raster font_fixed_231 = { 6, 13, 1, 1, font_fixed_231_pixels, 0 };

static u_int32_t font_fixed_232_pixels[] = {
	0,0,0xc0000000,0x30000000,0,0x70000000,0x88000000,0xf8000000,0x80000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_232 = { 6, 13, 1, 1, font_fixed_232_pixels, 0 };

static u_int32_t font_fixed_233_pixels[] = {
	0,0,0x18000000,0x60000000,0,0x70000000,0x88000000,0xf8000000,0x80000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_233 = { 6, 13, 1, 1, font_fixed_233_pixels, 0 };

static u_int32_t font_fixed_234_pixels[] = {
	0,0,0x20000000,0x50000000,0,0x70000000,0x88000000,0xf8000000,0x80000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_234 = { 6, 13, 1, 1, font_fixed_234_pixels, 0 };

static u_int32_t font_fixed_235_pixels[] = {
	0,0,0,0x50000000,0,0x70000000,0x88000000,0xf8000000,0x80000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_235 = { 6, 13, 1, 1, font_fixed_235_pixels, 0 };

static u_int32_t font_fixed_236_pixels[] = {
	0,0,0xc0000000,0x30000000,0,0x60000000,0x20000000,0x20000000,0x20000000,0x20000000,0x70000000,0,0
};
static struct raster font_fixed_236 = { 6, 13, 1, 1, font_fixed_236_pixels, 0 };

static u_int32_t font_fixed_237_pixels[] = {
	0,0,0x30000000,0xc0000000,0,0x60000000,0x20000000,0x20000000,0x20000000,0x20000000,0x70000000,0,0
};
static struct raster font_fixed_237 = { 6, 13, 1, 1, font_fixed_237_pixels, 0 };

static u_int32_t font_fixed_238_pixels[] = {
	0,0,0x20000000,0x50000000,0,0x60000000,0x20000000,0x20000000,0x20000000,0x20000000,0x70000000,0,0
};
static struct raster font_fixed_238 = { 6, 13, 1, 1, font_fixed_238_pixels, 0 };

static u_int32_t font_fixed_239_pixels[] = {
	0,0,0,0x50000000,0,0x60000000,0x20000000,0x20000000,0x20000000,0x20000000,0x70000000,0,0
};
static struct raster font_fixed_239 = { 6, 13, 1, 1, font_fixed_239_pixels, 0 };

static u_int32_t font_fixed_240_pixels[] = {
	0,0,0xd8000000,0x20000000,0xd0000000,0x8000000,0x78000000,0x88000000,0x88000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_240 = { 6, 13, 1, 1, font_fixed_240_pixels, 0 };

static u_int32_t font_fixed_241_pixels[] = {
	0,0,0x68000000,0xb0000000,0,0xb0000000,0xc8000000,0x88000000,0x88000000,0x88000000,0x88000000,0,0
};
static struct raster font_fixed_241 = { 6, 13, 1, 1, font_fixed_241_pixels, 0 };

static u_int32_t font_fixed_242_pixels[] = {
	0,0,0xc0000000,0x30000000,0,0x70000000,0x88000000,0x88000000,0x88000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_242 = { 6, 13, 1, 1, font_fixed_242_pixels, 0 };

static u_int32_t font_fixed_243_pixels[] = {
	0,0,0x18000000,0x60000000,0,0x70000000,0x88000000,0x88000000,0x88000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_243 = { 6, 13, 1, 1, font_fixed_243_pixels, 0 };

static u_int32_t font_fixed_244_pixels[] = {
	0,0,0x20000000,0x50000000,0,0x70000000,0x88000000,0x88000000,0x88000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_244 = { 6, 13, 1, 1, font_fixed_244_pixels, 0 };

static u_int32_t font_fixed_245_pixels[] = {
	0,0,0x68000000,0xb0000000,0,0x70000000,0x88000000,0x88000000,0x88000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_245 = { 6, 13, 1, 1, font_fixed_245_pixels, 0 };

static u_int32_t font_fixed_246_pixels[] = {
	0,0,0,0x50000000,0,0x70000000,0x88000000,0x88000000,0x88000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_246 = { 6, 13, 1, 1, font_fixed_246_pixels, 0 };

static u_int32_t font_fixed_247_pixels[] = {
	0,0,0,0x20000000,0x20000000,0,0xf8000000,0,0x20000000,0x20000000,0,0,0
};
static struct raster font_fixed_247 = { 6, 13, 1, 1, font_fixed_247_pixels, 0 };

static u_int32_t font_fixed_248_pixels[] = {
	0,0,0,0,0,0x78000000,0x98000000,0xa8000000,0xc8000000,0x88000000,0x70000000,0,0
};
static struct raster font_fixed_248 = { 6, 13, 1, 1, font_fixed_248_pixels, 0 };

static u_int32_t font_fixed_249_pixels[] = {
	0,0,0xc0000000,0x30000000,0,0x88000000,0x88000000,0x88000000,0x88000000,0x98000000,0x68000000,0,0
};
static struct raster font_fixed_249 = { 6, 13, 1, 1, font_fixed_249_pixels, 0 };

static u_int32_t font_fixed_250_pixels[] = {
	0,0,0x18000000,0x60000000,0,0x88000000,0x88000000,0x88000000,0x88000000,0x98000000,0x68000000,0,0
};
static struct raster font_fixed_250 = { 6, 13, 1, 1, font_fixed_250_pixels, 0 };

static u_int32_t font_fixed_251_pixels[] = {
	0,0,0x20000000,0x50000000,0,0x88000000,0x88000000,0x88000000,0x88000000,0x98000000,0x68000000,0,0
};
static struct raster font_fixed_251 = { 6, 13, 1, 1, font_fixed_251_pixels, 0 };

static u_int32_t font_fixed_252_pixels[] = {
	0,0,0,0x50000000,0,0x88000000,0x88000000,0x88000000,0x88000000,0x98000000,0x68000000,0,0
};
static struct raster font_fixed_252 = { 6, 13, 1, 1, font_fixed_252_pixels, 0 };

static u_int32_t font_fixed_253_pixels[] = {
	0,0,0x18000000,0x60000000,0,0x88000000,0x88000000,0x88000000,0x98000000,0x68000000,0x8000000,0x88000000,0x70000000
};
static struct raster font_fixed_253 = { 6, 13, 1, 1, font_fixed_253_pixels, 0 };

static u_int32_t font_fixed_254_pixels[] = {
	0,0,0x80000000,0x80000000,0xf0000000,0x88000000,0x88000000,0x88000000,0x88000000,0xf0000000,0x80000000,0x80000000,0
};
static struct raster font_fixed_254 = { 6, 13, 1, 1, font_fixed_254_pixels, 0 };

static u_int32_t font_fixed_255_pixels[] = {
	0,0,0x50000000,0,0,0x88000000,0x88000000,0x88000000,0x98000000,0x68000000,0x8000000,0x88000000,0x70000000
};
static struct raster font_fixed_255 = { 6, 13, 1, 1, font_fixed_255_pixels, 0 };

struct raster_font font_fixed = {
    6, 13, 10, RASFONT_FIXEDWIDTH|RASFONT_NOVERTICALMOVEMENT,
    {
	{ &font_fixed_0, 0, -10, 6, 0 },
	{ &font_fixed_1, 0, -10, 6, 0 },
	{ &font_fixed_2, 0, -10, 6, 0 },
	{ &font_fixed_3, 0, -10, 6, 0 },
	{ &font_fixed_4, 0, -10, 6, 0 },
	{ &font_fixed_5, 0, -10, 6, 0 },
	{ &font_fixed_6, 0, -10, 6, 0 },
	{ &font_fixed_7, 0, -10, 6, 0 },
	{ &font_fixed_8, 0, -10, 6, 0 },
	{ &font_fixed_9, 0, -10, 6, 0 },
	{ &font_fixed_10, 0, -10, 6, 0 },
	{ &font_fixed_11, 0, -10, 6, 0 },
	{ &font_fixed_12, 0, -10, 6, 0 },
	{ &font_fixed_13, 0, -10, 6, 0 },
	{ &font_fixed_14, 0, -10, 6, 0 },
	{ &font_fixed_15, 0, -10, 6, 0 },
	{ &font_fixed_16, 0, -10, 6, 0 },
	{ &font_fixed_17, 0, -10, 6, 0 },
	{ &font_fixed_18, 0, -10, 6, 0 },
	{ &font_fixed_19, 0, -10, 6, 0 },
	{ &font_fixed_20, 0, -10, 6, 0 },
	{ &font_fixed_21, 0, -10, 6, 0 },
	{ &font_fixed_22, 0, -10, 6, 0 },
	{ &font_fixed_23, 0, -10, 6, 0 },
	{ &font_fixed_24, 0, -10, 6, 0 },
	{ &font_fixed_25, 0, -10, 6, 0 },
	{ &font_fixed_26, 0, -10, 6, 0 },
	{ &font_fixed_27, 0, -10, 6, 0 },
	{ &font_fixed_28, 0, -10, 6, 0 },
	{ &font_fixed_29, 0, -10, 6, 0 },
	{ &font_fixed_30, 0, -10, 6, 0 },
	{ &font_fixed_31, 0, -10, 6, 0 },
	{ &font_fixed_32, 0, -10, 6, 0 },
	{ &font_fixed_33, 0, -10, 6, 0 },
	{ &font_fixed_34, 0, -10, 6, 0 },
	{ &font_fixed_35, 0, -10, 6, 0 },
	{ &font_fixed_36, 0, -10, 6, 0 },
	{ &font_fixed_37, 0, -10, 6, 0 },
	{ &font_fixed_38, 0, -10, 6, 0 },
	{ &font_fixed_39, 0, -10, 6, 0 },
	{ &font_fixed_40, 0, -10, 6, 0 },
	{ &font_fixed_41, 0, -10, 6, 0 },
	{ &font_fixed_42, 0, -10, 6, 0 },
	{ &font_fixed_43, 0, -10, 6, 0 },
	{ &font_fixed_44, 0, -10, 6, 0 },
	{ &font_fixed_45, 0, -10, 6, 0 },
	{ &font_fixed_46, 0, -10, 6, 0 },
	{ &font_fixed_47, 0, -10, 6, 0 },
	{ &font_fixed_48, 0, -10, 6, 0 },
	{ &font_fixed_49, 0, -10, 6, 0 },
	{ &font_fixed_50, 0, -10, 6, 0 },
	{ &font_fixed_51, 0, -10, 6, 0 },
	{ &font_fixed_52, 0, -10, 6, 0 },
	{ &font_fixed_53, 0, -10, 6, 0 },
	{ &font_fixed_54, 0, -10, 6, 0 },
	{ &font_fixed_55, 0, -10, 6, 0 },
	{ &font_fixed_56, 0, -10, 6, 0 },
	{ &font_fixed_57, 0, -10, 6, 0 },
	{ &font_fixed_58, 0, -10, 6, 0 },
	{ &font_fixed_59, 0, -10, 6, 0 },
	{ &font_fixed_60, 0, -10, 6, 0 },
	{ &font_fixed_61, 0, -10, 6, 0 },
	{ &font_fixed_62, 0, -10, 6, 0 },
	{ &font_fixed_63, 0, -10, 6, 0 },
	{ &font_fixed_64, 0, -10, 6, 0 },
	{ &font_fixed_65, 0, -10, 6, 0 },
	{ &font_fixed_66, 0, -10, 6, 0 },
	{ &font_fixed_67, 0, -10, 6, 0 },
	{ &font_fixed_68, 0, -10, 6, 0 },
	{ &font_fixed_69, 0, -10, 6, 0 },
	{ &font_fixed_70, 0, -10, 6, 0 },
	{ &font_fixed_71, 0, -10, 6, 0 },
	{ &font_fixed_72, 0, -10, 6, 0 },
	{ &font_fixed_73, 0, -10, 6, 0 },
	{ &font_fixed_74, 0, -10, 6, 0 },
	{ &font_fixed_75, 0, -10, 6, 0 },
	{ &font_fixed_76, 0, -10, 6, 0 },
	{ &font_fixed_77, 0, -10, 6, 0 },
	{ &font_fixed_78, 0, -10, 6, 0 },
	{ &font_fixed_79, 0, -10, 6, 0 },
	{ &font_fixed_80, 0, -10, 6, 0 },
	{ &font_fixed_81, 0, -10, 6, 0 },
	{ &font_fixed_82, 0, -10, 6, 0 },
	{ &font_fixed_83, 0, -10, 6, 0 },
	{ &font_fixed_84, 0, -10, 6, 0 },
	{ &font_fixed_85, 0, -10, 6, 0 },
	{ &font_fixed_86, 0, -10, 6, 0 },
	{ &font_fixed_87, 0, -10, 6, 0 },
	{ &font_fixed_88, 0, -10, 6, 0 },
	{ &font_fixed_89, 0, -10, 6, 0 },
	{ &font_fixed_90, 0, -10, 6, 0 },
	{ &font_fixed_91, 0, -10, 6, 0 },
	{ &font_fixed_92, 0, -10, 6, 0 },
	{ &font_fixed_93, 0, -10, 6, 0 },
	{ &font_fixed_94, 0, -10, 6, 0 },
	{ &font_fixed_95, 0, -10, 6, 0 },
	{ &font_fixed_96, 0, -10, 6, 0 },
	{ &font_fixed_97, 0, -10, 6, 0 },
	{ &font_fixed_98, 0, -10, 6, 0 },
	{ &font_fixed_99, 0, -10, 6, 0 },
	{ &font_fixed_100, 0, -10, 6, 0 },
	{ &font_fixed_101, 0, -10, 6, 0 },
	{ &font_fixed_102, 0, -10, 6, 0 },
	{ &font_fixed_103, 0, -10, 6, 0 },
	{ &font_fixed_104, 0, -10, 6, 0 },
	{ &font_fixed_105, 0, -10, 6, 0 },
	{ &font_fixed_106, 0, -10, 6, 0 },
	{ &font_fixed_107, 0, -10, 6, 0 },
	{ &font_fixed_108, 0, -10, 6, 0 },
	{ &font_fixed_109, 0, -10, 6, 0 },
	{ &font_fixed_110, 0, -10, 6, 0 },
	{ &font_fixed_111, 0, -10, 6, 0 },
	{ &font_fixed_112, 0, -10, 6, 0 },
	{ &font_fixed_113, 0, -10, 6, 0 },
	{ &font_fixed_114, 0, -10, 6, 0 },
	{ &font_fixed_115, 0, -10, 6, 0 },
	{ &font_fixed_116, 0, -10, 6, 0 },
	{ &font_fixed_117, 0, -10, 6, 0 },
	{ &font_fixed_118, 0, -10, 6, 0 },
	{ &font_fixed_119, 0, -10, 6, 0 },
	{ &font_fixed_120, 0, -10, 6, 0 },
	{ &font_fixed_121, 0, -10, 6, 0 },
	{ &font_fixed_122, 0, -10, 6, 0 },
	{ &font_fixed_123, 0, -10, 6, 0 },
	{ &font_fixed_124, 0, -10, 6, 0 },
	{ &font_fixed_125, 0, -10, 6, 0 },
	{ &font_fixed_126, 0, -10, 6, 0 },
	{ &font_fixed_127, 0, -10, 6, 0 },
	null32,
	{ &font_fixed_160, 0, -10, 6, 0 },
	{ &font_fixed_161, 0, -10, 6, 0 },
	{ &font_fixed_162, 0, -10, 6, 0 },
	{ &font_fixed_163, 0, -10, 6, 0 },
	{ &font_fixed_164, 0, -10, 6, 0 },
	{ &font_fixed_165, 0, -10, 6, 0 },
	{ &font_fixed_166, 0, -10, 6, 0 },
	{ &font_fixed_167, 0, -10, 6, 0 },
	{ &font_fixed_168, 0, -10, 6, 0 },
	{ &font_fixed_169, 0, -10, 6, 0 },
	{ &font_fixed_170, 0, -10, 6, 0 },
	{ &font_fixed_171, 0, -10, 6, 0 },
	{ &font_fixed_172, 0, -10, 6, 0 },
	{ &font_fixed_173, 0, -10, 6, 0 },
	{ &font_fixed_174, 0, -10, 6, 0 },
	{ &font_fixed_175, 0, -10, 6, 0 },
	{ &font_fixed_176, 0, -10, 6, 0 },
	{ &font_fixed_177, 0, -10, 6, 0 },
	{ &font_fixed_178, 0, -10, 6, 0 },
	{ &font_fixed_179, 0, -10, 6, 0 },
	{ &font_fixed_180, 0, -10, 6, 0 },
	{ &font_fixed_181, 0, -10, 6, 0 },
	{ &font_fixed_182, 0, -10, 6, 0 },
	{ &font_fixed_183, 0, -10, 6, 0 },
	{ &font_fixed_184, 0, -10, 6, 0 },
	{ &font_fixed_185, 0, -10, 6, 0 },
	{ &font_fixed_186, 0, -10, 6, 0 },
	{ &font_fixed_187, 0, -10, 6, 0 },
	{ &font_fixed_188, 0, -10, 6, 0 },
	{ &font_fixed_189, 0, -10, 6, 0 },
	{ &font_fixed_190, 0, -10, 6, 0 },
	{ &font_fixed_191, 0, -10, 6, 0 },
	{ &font_fixed_192, 0, -10, 6, 0 },
	{ &font_fixed_193, 0, -10, 6, 0 },
	{ &font_fixed_194, 0, -10, 6, 0 },
	{ &font_fixed_195, 0, -10, 6, 0 },
	{ &font_fixed_196, 0, -10, 6, 0 },
	{ &font_fixed_197, 0, -10, 6, 0 },
	{ &font_fixed_198, 0, -10, 6, 0 },
	{ &font_fixed_199, 0, -10, 6, 0 },
	{ &font_fixed_200, 0, -10, 6, 0 },
	{ &font_fixed_201, 0, -10, 6, 0 },
	{ &font_fixed_202, 0, -10, 6, 0 },
	{ &font_fixed_203, 0, -10, 6, 0 },
	{ &font_fixed_204, 0, -10, 6, 0 },
	{ &font_fixed_205, 0, -10, 6, 0 },
	{ &font_fixed_206, 0, -10, 6, 0 },
	{ &font_fixed_207, 0, -10, 6, 0 },
	{ &font_fixed_208, 0, -10, 6, 0 },
	{ &font_fixed_209, 0, -10, 6, 0 },
	{ &font_fixed_210, 0, -10, 6, 0 },
	{ &font_fixed_211, 0, -10, 6, 0 },
	{ &font_fixed_212, 0, -10, 6, 0 },
	{ &font_fixed_213, 0, -10, 6, 0 },
	{ &font_fixed_214, 0, -10, 6, 0 },
	{ &font_fixed_215, 0, -10, 6, 0 },
	{ &font_fixed_216, 0, -10, 6, 0 },
	{ &font_fixed_217, 0, -10, 6, 0 },
	{ &font_fixed_218, 0, -10, 6, 0 },
	{ &font_fixed_219, 0, -10, 6, 0 },
	{ &font_fixed_220, 0, -10, 6, 0 },
	{ &font_fixed_221, 0, -10, 6, 0 },
	{ &font_fixed_222, 0, -10, 6, 0 },
	{ &font_fixed_223, 0, -10, 6, 0 },
	{ &font_fixed_224, 0, -10, 6, 0 },
	{ &font_fixed_225, 0, -10, 6, 0 },
	{ &font_fixed_226, 0, -10, 6, 0 },
	{ &font_fixed_227, 0, -10, 6, 0 },
	{ &font_fixed_228, 0, -10, 6, 0 },
	{ &font_fixed_229, 0, -10, 6, 0 },
	{ &font_fixed_230, 0, -10, 6, 0 },
	{ &font_fixed_231, 0, -10, 6, 0 },
	{ &font_fixed_232, 0, -10, 6, 0 },
	{ &font_fixed_233, 0, -10, 6, 0 },
	{ &font_fixed_234, 0, -10, 6, 0 },
	{ &font_fixed_235, 0, -10, 6, 0 },
	{ &font_fixed_236, 0, -10, 6, 0 },
	{ &font_fixed_237, 0, -10, 6, 0 },
	{ &font_fixed_238, 0, -10, 6, 0 },
	{ &font_fixed_239, 0, -10, 6, 0 },
	{ &font_fixed_240, 0, -10, 6, 0 },
	{ &font_fixed_241, 0, -10, 6, 0 },
	{ &font_fixed_242, 0, -10, 6, 0 },
	{ &font_fixed_243, 0, -10, 6, 0 },
	{ &font_fixed_244, 0, -10, 6, 0 },
	{ &font_fixed_245, 0, -10, 6, 0 },
	{ &font_fixed_246, 0, -10, 6, 0 },
	{ &font_fixed_247, 0, -10, 6, 0 },
	{ &font_fixed_248, 0, -10, 6, 0 },
	{ &font_fixed_249, 0, -10, 6, 0 },
	{ &font_fixed_250, 0, -10, 6, 0 },
	{ &font_fixed_251, 0, -10, 6, 0 },
	{ &font_fixed_252, 0, -10, 6, 0 },
	{ &font_fixed_253, 0, -10, 6, 0 },
	{ &font_fixed_254, 0, -10, 6, 0 },
	{ &font_fixed_255, 0, -10, 6, 0 },
    },
#ifdef COLORFONT_CACHE
    (struct raster_fontcache*) -1
#endif /*COLORFONT_CACHE*/
};
#endif /* a font that is not to big. */

